import { default as Alert } from './alert.vue';
import { PuikAriaLive } from '@prestashopcorp/puik-components/base/src/common';
export declare enum PuikAlertVariants {
    Success = "success",
    Warning = "warning",
    Danger = "danger",
    Info = "info"
}
export declare const ICONS: {
    success: string;
    warning: string;
    danger: string;
    info: string;
};
export interface AlertProps {
    title?: string;
    description?: string;
    variant?: `${PuikAlertVariants}`;
    isClosable?: boolean;
    disableBorders?: boolean;
    buttonLabel?: string;
    linkLabel?: string;
    buttonWrapLabel?: boolean;
    leftIconBtn?: string;
    rightIconBtn?: string;
    leftIconLink?: string;
    rightIconLink?: string;
    internalLink?: string;
    externalLink?: string;
    ariaLive?: `${PuikAriaLive}`;
    ariaLabelBtn?: string;
    ariaLabelLink?: string;
    dataTest?: string;
}
export type AlertEmits = {
    click: [event: Event];
    clickLink: [event: Event];
    close: [event: Event];
};
export type AlertInstance = InstanceType<typeof Alert>;
