import { defineComponent as B, computed as S, createElementBlock as o, openBlock as e, mergeProps as s, createElementVNode as d, createBlock as p, createCommentVNode as i, createVNode as I, unref as n, toDisplayString as l, renderSlot as $, createTextVNode as k, withCtx as u } from "vue";
import { generateId as T } from "../../utils/rand.mjs";
import { PuikButton as c } from "../../button/index.mjs";
import { PuikIcon as b } from "../../icon/index.mjs";
import { PuikAriaLive as C } from "../../base/src/common.mjs";
import { PuikAlertVariants as P, ICONS as w } from "./alert.mjs";
const N = ["aria-live", "data-test"], V = { class: "puik-alert__container" }, A = { class: "puik-alert__content" }, W = { class: "puik-alert__text" }, z = ["id", "data-test"], E = ["id", "data-test"], J = /* @__PURE__ */ B({
  name: "PuikAlert",
  __name: "alert",
  props: {
    title: { type: String },
    description: { type: String },
    variant: { default: P.Success, type: null },
    isClosable: { type: Boolean },
    disableBorders: { type: Boolean },
    buttonLabel: { type: String },
    linkLabel: { type: String },
    buttonWrapLabel: { type: Boolean },
    leftIconBtn: { type: String },
    rightIconBtn: { type: String },
    leftIconLink: { type: String },
    rightIconLink: { type: String },
    internalLink: { type: String },
    externalLink: { type: String },
    ariaLive: { default: C.Polite, type: null },
    ariaLabelBtn: { type: String },
    ariaLabelLink: { type: String },
    dataTest: { type: String }
  },
  emits: ["click", "clickLink", "close"],
  setup(L, { emit: m }) {
    const f = L, r = m, a = `${T()}`, v = S(() => w[f.variant]), y = (t) => r("click", t), g = (t) => r("close", t), h = (t) => r("clickLink", t);
    return (t, D) => (e(), o("div", s({
      class: ["puik-alert", [
        `puik-alert--${t.variant}`,
        { "puik-alert--no-borders": t.disableBorders }
      ]],
      role: "alert"
    }, {
      ...t.title && t.title.trim() && { "aria-labelledby": `title-${a}` },
      ...(t.$slots.default || t.description && t.description.trim()) && { "aria-describedby": `description-${a}` }
    }, {
      "aria-live": t.ariaLive,
      "data-test": t.dataTest,
      tabindex: "0"
    }), [
      d("div", V, [
        d("div", A, [
          I(n(b), {
            icon: v.value,
            "font-size": "1.25rem",
            class: "puik-alert__icon"
          }, null, 8, ["icon"]),
          d("div", W, [
            t.title ? (e(), o("h4", {
              key: 0,
              id: `title-${a}`,
              class: "puik-alert__title",
              "data-test": t.dataTest != null ? `title-${t.dataTest}` : void 0
            }, l(t.title), 9, z)) : i("", !0),
            t.$slots.default || t.description ? (e(), o("p", {
              key: 1,
              id: `description-${a}`,
              class: "puik-alert__description",
              "data-test": t.dataTest != null ? `description-${t.dataTest}` : void 0
            }, [
              $(t.$slots, "default", {}, () => [
                k(l(t.description), 1)
              ])
            ], 8, E)) : i("", !0)
          ])
        ]),
        t.linkLabel ? (e(), p(n(c), s({ key: 0 }, {
          ...t.leftIconLink ? { "left-icon": t.leftIconLink } : {},
          ...t.rightIconLink ? { "right-icon": t.rightIconLink } : {},
          ...t.internalLink ? { to: t.internalLink } : {},
          ...t.externalLink ? { href: t.externalLink } : {},
          ...t.ariaLabelLink ? { "aria-label": t.ariaLabelLink } : {}
        }, {
          class: "puik-alert__link",
          "data-test": t.dataTest != null ? `link-${t.dataTest}` : void 0,
          tabindex: "0",
          variant: "text",
          "wrap-label": t.buttonWrapLabel,
          onClick: h
        }), {
          default: u(() => [
            k(l(t.linkLabel), 1)
          ]),
          _: 1
        }, 16, ["data-test", "wrap-label"])) : i("", !0),
        t.buttonLabel ? (e(), p(n(c), s({ key: 1 }, {
          ...t.leftIconBtn ? { "left-icon": t.leftIconBtn } : {},
          ...t.rightIconBtn ? { "right-icon": t.rightIconBtn } : {},
          ...t.ariaLabelBtn ? { "aria-label": t.ariaLabelBtn } : {}
        }, {
          variant: t.variant,
          "wrap-label": t.buttonWrapLabel,
          class: "puik-alert__button",
          "data-test": t.dataTest != null ? `button-${t.dataTest}` : void 0,
          onClick: y
        }), {
          default: u(() => [
            k(l(t.buttonLabel), 1)
          ]),
          _: 1
        }, 16, ["variant", "wrap-label", "data-test"])) : i("", !0)
      ]),
      t.isClosable ? (e(), p(n(b), {
        key: 0,
        icon: "close",
        "font-size": "1.5rem",
        class: "puik-alert__close",
        "data-test": t.dataTest != null ? `close-${t.dataTest}` : void 0,
        onClick: g
      }, null, 8, ["data-test"])) : i("", !0)
    ], 16, N));
  }
});
export {
  J as default
};
