import { defineComponent as g, computed as n, createElementBlock as d, openBlock as o, normalizeClass as p, createBlock as k, unref as i, toDisplayString as T } from "vue";
import { useLocale as S } from "../../locale/hooks/use-locale.mjs";
import { getInitialLetter as u } from "../../utils/getInitialLetter.mjs";
import { PuikIcon as N } from "../../icon/index.mjs";
import { PuikAvatarType as l, PuikAvatarSize as b, PuikAvatarMode as I, AVATAR_MODE as A, ICONS_FONTSIZE as P } from "./avatar.mjs";
const h = ["id", "data-test", "aria-label"], z = ["src", "alt", "data-test"], $ = ["data-test", "aria-label"], O = /* @__PURE__ */ g({
  name: "PuikAvatar",
  __name: "avatar",
  props: {
    id: { type: String },
    mode: { default: I.Primary, type: null },
    size: { default: b.Medium, type: null },
    type: { default: l.Initials, type: null },
    icon: { type: String },
    src: { type: String },
    alt: { type: String },
    firstName: { default: "", type: String },
    lastName: { default: "", type: String },
    singleInitial: { type: null },
    dataTest: { type: String },
    ariaLabel: { type: String }
  },
  setup(m) {
    const t = m, { t: v } = S(), s = v("puik.avatar.altDefault"), r = n(() => {
      const a = t.firstName ? u(t.firstName, 0) : "", e = t.lastName ? u(t.lastName, 0) : "";
      return t.singleInitial ? a || e || "P" : a && e ? a + e : a && t.firstName.length > 1 ? a + u(t.firstName, 1) : e && t.lastName.length > 1 ? e + u(t.lastName, 1) : "PS";
    }), f = n(() => t.type === l.Photo ? t.alt || s : t.type === l.Icon ? t.icon || s : r.value), c = n(() => t.icon || s), y = n(() => r.value);
    return (a, e) => (o(), d("div", {
      id: a.id,
      class: p(`puik-avatar puik-avatar--${a.size} puik-avatar--${a.type} puik-avatar--${a.mode}`),
      "data-test": a.dataTest,
      role: "img",
      "aria-label": a.ariaLabel || f.value,
      tabindex: "0"
    }, [
      a.src && a.type == i(l).Photo ? (o(), d("img", {
        key: 0,
        src: a.src,
        alt: a.alt || i(s),
        "data-test": a.dataTest != null ? `image-${a.dataTest}` : void 0
      }, null, 8, z)) : a.icon && a.type == i(l).Icon ? (o(), k(i(N), {
        key: 1,
        icon: a.icon,
        "font-size": i(P)[t.size],
        color: i(A)[t.mode],
        "data-test": a.dataTest != null ? `icon-${a.dataTest}` : void 0,
        role: "img",
        "aria-label": a.ariaLabel || c.value
      }, null, 8, ["icon", "font-size", "color", "data-test", "aria-label"])) : (o(), d("div", {
        key: r.value,
        class: p(`puik-avatar_initials puik-avatar_initials--${a.size}`),
        "data-test": a.dataTest != null ? `initials-${a.dataTest}` : void 0,
        role: "img",
        "aria-label": a.ariaLabel || y.value
      }, T(r.value), 11, $))
    ], 10, h));
  }
});
export {
  O as default
};
