import { defineComponent as g, inject as h, computed as n, createBlock as a, openBlock as i, resolveDynamicComponent as z, mergeProps as P, withCtx as B, createCommentVNode as r, renderSlot as S, createElementBlock as I, unref as o, toDisplayString as L } from "vue";
import { useLocale as T } from "../../locale/hooks/use-locale.mjs";
import { generateId as $ } from "../../utils/rand.mjs";
import "../../config-provider/src/config-provider.mjs";
import { PuikButtonLoaderPositions as s, PuikButtonSizes as C, PuikButtonVariants as D } from "./button.mjs";
import "../../input/src/input.vue2.mjs";
import "../../alert/src/alert.vue2.mjs";
import "../../tooltip/src/tooltip.vue2.mjs";
import "@headlessui/vue";
import "@vueuse/core";
import "../../link/src/link.vue2.mjs";
import "../../card/src/card.vue2.mjs";
import "@vueuse/components";
import { PuikIcon as p } from "../../icon/index.mjs";
import "../../pagination/src/pagination.vue2.mjs";
import "../../badge/src/badge.vue2.mjs";
import { ButtonGroupKey as R } from "../../button-group/src/button-group.mjs";
import "../../skeleton-loader/src/skeleton-loader.vue2.mjs";
import "../../modal/src/modal.vue2.mjs";
import "../../snackbar/src/snackbar.vue2.mjs";
import "../../snackbar/src/snackbar-provider.vue2.mjs";
import "../../table/src/table-search-input.vue2.mjs";
import { PuikSpinnerLoader as m } from "../../spinner-loader/index.mjs";
import "../../menu/src/menu.vue2.mjs";
import "../../chip/src/chip.vue2.mjs";
import "../../tag/src/tag.vue2.mjs";
import "../../avatar/src/avatar.vue2.mjs";
import "../../divider/src/divider.vue2.mjs";
import "../../notification-bar/src/notification-bar.vue2.mjs";
import "../../sortable-list/src/sortable-list.vue2.mjs";
import "../../rating-card/src/rating-card.vue2.mjs";
const ut = /* @__PURE__ */ g({
  name: "PuikButton",
  __name: "button",
  props: {
    variant: { default: D.Primary, type: null },
    size: { default: C.Medium, type: null },
    fluid: { type: Boolean },
    wrapLabel: { type: Boolean },
    disabled: { type: Boolean },
    disabledReason: { type: String },
    leftIcon: { type: String },
    rightIcon: { type: String },
    loading: { type: Boolean, default: !1 },
    loaderPosition: { default: s.Right, type: null },
    to: { type: null },
    href: { type: String },
    value: { type: [String, Number, Object, Array] },
    dataTest: { type: String },
    ariaLabel: { type: String }
  },
  setup(b) {
    const e = b, { t: f } = T(), c = f("puik.common.ariaDisabledDescription"), d = `puik-button-disabled-${$()}`, l = h(R, void 0), y = n(() => e.to ? "router-link" : e.href ? "a" : "button"), k = n(
      () => e.to ? { to: e.to } : { href: e.href }
    ), v = () => {
      l && e.value && (l.selected.value = e.value);
    }, u = n(() => e.variant === "primary" || e.variant === "secondary-reverse" || e.variant === "text-reverse" || e.variant === "destructive" || e.disabled ? "reverse" : "primary");
    return (t, w) => (i(), a(z(y.value), P({
      ...k.value,
      ...t.ariaLabel ? { "aria-label": t.ariaLabel } : {}
    }, {
      class: ["puik-button", [
        `puik-button--${t.variant}`,
        `puik-button--${t.size}`,
        { "puik-button--disabled": t.disabled },
        { "puik-button--fluid": t.fluid },
        { "puik-button--no-wrap": !t.wrapLabel }
      ]],
      role: "button",
      disabled: t.disabled,
      "aria-disabled": t.disabled ? "true" : void 0,
      "aria-describedby": t.disabled ? d : void 0,
      "data-test": t.dataTest,
      onClick: v
    }), {
      default: B(() => [
        e.loading && e.loaderPosition === o(s).Left ? (i(), a(o(m), {
          key: 0,
          size: e.size,
          color: u.value,
          class: "puik-button__loader puik-button__loader--left",
          "data-test": t.dataTest != null ? `leftLoader-${t.dataTest}` : void 0
        }, null, 8, ["size", "color", "data-test"])) : r("", !0),
        t.leftIcon ? (i(), a(o(p), {
          key: 1,
          icon: t.leftIcon,
          "font-size": t.size !== "sm" ? "1.25rem" : "1rem",
          class: "puik-button__left-icon",
          "aria-hidden": !0,
          "data-test": t.dataTest != null ? `leftIcon-${t.dataTest}` : void 0
        }, null, 8, ["icon", "font-size", "data-test"])) : r("", !0),
        S(t.$slots, "default"),
        t.rightIcon ? (i(), a(o(p), {
          key: 2,
          icon: t.rightIcon,
          "font-size": t.size !== "sm" ? "1.25rem" : "1rem",
          class: "puik-button__right-icon",
          "aria-hidden": !0,
          "data-test": t.dataTest != null ? `rightIcon-${t.dataTest}` : void 0
        }, null, 8, ["icon", "font-size", "data-test"])) : r("", !0),
        e.loading && e.loaderPosition === o(s).Right ? (i(), a(o(m), {
          key: 3,
          size: e.size,
          color: u.value,
          class: "puik-button__loader puik-button__loader--right",
          "data-test": t.dataTest != null ? `rightLoader-${t.dataTest}` : void 0
        }, null, 8, ["size", "color", "data-test"])) : r("", !0),
        t.disabled ? (i(), I("span", {
          key: 4,
          id: d,
          class: "puik-sr-only"
        }, L(t.disabledReason ?? o(c)) + ". ", 1)) : r("", !0)
      ]),
      _: 3
    }, 16, ["class", "disabled", "aria-disabled", "aria-describedby", "data-test"]));
  }
});
export {
  ut as default
};
