import { defineComponent as P, useSlots as E, ref as b, computed as p, createElementBlock as r, openBlock as a, createCommentVNode as s, createElementVNode as u, toDisplayString as o, normalizeClass as k, withDirectives as f, createBlock as F, renderSlot as d, mergeProps as C, vModelDynamic as q, withKeys as g, withModifiers as D, vShow as K, createVNode as z, unref as A, createTextVNode as H } from "vue";
import { PuikAriaLive as M } from "../../base/src/common.mjs";
import { PuikIcon as Y } from "../../icon/index.mjs";
import { isNumber as y, slotIsEmpty as G } from "../../utils/types.mjs";
import O from "./controls/controls.vue2.mjs";
import { PuikInputTypes as U } from "./input.mjs";
const j = ["data-test"], J = ["for"], Q = {
  key: 0,
  class: "puik-input__prepend"
}, R = ["placeholder", "disabled", "type", "required", "autocomplete", "name", "min", "max", "minlength", "maxlength", "step", "data-test", "aria-label", "aria-live"], W = ["aria-pressed", "onKeydown"], X = {
  key: 2,
  class: "puik-input__append"
}, Z = {
  key: 1,
  class: "puik-input__hint"
}, x = {
  key: 0,
  class: "puik-input__hint__text"
}, ee = {
  key: 1,
  class: "puik-input__hint__error",
  role: "alert"
}, te = ["data-test"], le = /* @__PURE__ */ P({
  name: "PuikInput",
  __name: "input",
  props: {
    modelValue: { type: [String, Number] },
    type: { default: U.Text, type: null },
    id: { type: String },
    srLabel: { type: String },
    placeholder: { type: String },
    disabled: { type: Boolean },
    name: { type: String },
    autocomplete: { type: String },
    step: { default: 1, type: Number },
    precision: { type: Number },
    min: { default: Number.NEGATIVE_INFINITY, type: Number },
    max: { default: Number.POSITIVE_INFINITY, type: Number },
    minLength: { type: Number },
    maxLength: { type: Number },
    required: { type: Boolean },
    error: { type: String },
    success: { type: Boolean },
    hideHint: { type: Boolean },
    dataTest: { type: String },
    ariaLabel: { type: String },
    ariaLive: { default: M.Polite, type: null }
  },
  emits: ["update:modelValue"],
  setup(_, { emit: L }) {
    const t = _, N = L, w = E(), m = b(!1), n = b(!1), I = () => m.value = !0, S = () => m.value = !1, v = () => n.value = !n.value, i = p({
      get() {
        return y(t.modelValue) ? parseFloat(t.modelValue.toFixed(t.precision)) : t.modelValue;
      },
      set(e) {
        N("update:modelValue", e);
      }
    }), V = () => {
      y(i.value) && i.value < t.max && (i.value += t.step);
    }, T = () => {
      y(i.value) && i.value > t.min && (i.value -= t.step);
    }, l = p(() => t.error || G(w.error)), h = p(() => {
      var e;
      return ((e = i.value) == null ? void 0 : e.toString().length) || 0;
    }), $ = p(() => ({
      "puik-input__wrapper--focus": m.value,
      "puik-input__wrapper--disabled": t.disabled,
      "puik-input__wrapper--success": t.success,
      "puik-input__wrapper--error": l.value
    }));
    return (e, c) => (a(), r("div", {
      class: "puik-input",
      "data-test": e.dataTest
    }, [
      e.srLabel && e.id ? (a(), r("label", {
        key: 0,
        for: e.id,
        class: "puik-sr-only"
      }, o(e.srLabel), 9, J)) : s("", !0),
      u("div", {
        class: k(["puik-input__wrapper", $.value])
      }, [
        e.$slots.prepend ? (a(), r("div", Q, [
          d(e.$slots, "prepend")
        ])) : s("", !0),
        f(u("input", C({
          ...e.id ? { id: e.id } : {},
          ...e.$attrs
        }, {
          "onUpdate:modelValue": c[0] || (c[0] = (B) => i.value = B),
          class: "puik-input__field",
          placeholder: e.placeholder,
          disabled: e.disabled,
          type: n.value ? "text" : e.type,
          required: e.required,
          autocomplete: e.autocomplete,
          name: e.name,
          min: e.type === "number" ? e.min : void 0,
          max: e.type === "number" ? e.max : void 0,
          minlength: e.minLength,
          maxlength: e.maxLength,
          step: e.type === "number" ? e.step : void 0,
          "data-test": e.dataTest != null ? `input-${e.dataTest}` : void 0,
          "aria-label": e.ariaLabel ? e.ariaLabel : e.srLabel ? e.srLabel : "undefined",
          "aria-live": e.ariaLive,
          onFocus: I,
          onBlur: S
        }), null, 16, R), [
          [q, i.value]
        ]),
        e.type === "password" ? (a(), r("span", {
          key: 1,
          class: "puik-input__reveal-password",
          role: "button",
          "aria-pressed": n.value ? "true" : "false",
          tabindex: "0",
          onClick: v,
          onKeydown: [
            g(v, ["enter"]),
            g(D(v, ["prevent"]), ["space"])
          ]
        }, o(n.value ? "visibility" : "visibility_off"), 41, W)) : e.$slots.append ? (a(), r("div", X, [
          d(e.$slots, "append")
        ])) : s("", !0),
        e.type === "number" ? (a(), F(O, {
          key: 3,
          disabled: e.disabled,
          onIncrease: V,
          onDecrease: T
        }, null, 8, ["disabled"])) : s("", !0)
      ], 2),
      e.$slots.hint || l.value ? (a(), r("div", Z, [
        e.$slots.hint && !l.value ? f((a(), r("span", x, [
          d(e.$slots, "hint")
        ], 512)), [
          [K, !e.hideHint]
        ]) : s("", !0),
        l.value ? (a(), r("div", ee, [
          z(A(Y), {
            icon: "error",
            class: "puik-input__hint__error__icon",
            "font-size": "1.25rem"
          }),
          u("span", {
            class: "puik-input__hint__error__text",
            "data-test": e.dataTest != null ? `error-${e.dataTest}` : void 0
          }, [
            d(e.$slots, "error", {}, () => [
              H(o(e.error), 1)
            ])
          ], 8, te)
        ])) : s("", !0)
      ])) : s("", !0),
      t.maxLength ? (a(), r("div", {
        key: 2,
        class: k([
          "puik-input__character-count",
          {
            "puik-input__character-count--error": h.value > (t.maxLength ?? 0)
          }
        ])
      }, [
        u("span", null, o(h.value) + "/" + o(e.maxLength), 1)
      ], 2)) : s("", !0)
    ], 8, j));
  }
});
export {
  le as default
};
