import { defineComponent as w, computed as m, ref as c, watch as z, nextTick as M, createBlock as d, openBlock as i, unref as a, normalizeClass as B, withCtx as n, createElementVNode as p, createVNode as g, createElementBlock as C, createCommentVNode as s, toDisplayString as u, createTextVNode as v, renderSlot as h } from "vue";
import { Dialog as O, DialogPanel as A } from "@headlessui/vue";
import { useWindowSize as F } from "@vueuse/core";
import { PuikButton as k } from "../../button/index.mjs";
import { PuikIcon as y } from "../../icon/index.mjs";
import { PuikTooltip as R } from "../../tooltip/index.mjs";
import { isEllipsisActive as U } from "../../utils/isEllipsisActive.mjs";
import { modalEmits as W, PuikModalSizes as Z, PuikModalVariants as l, DESTRUCTIVE_ICON_NAME as j } from "./modal.mjs";
const q = { class: "puik-modal__dialogPanelContainer" }, G = {
  key: 0,
  class: "puik-modal__dialogPanelContainer__dialogPanel__header"
}, H = ["data-test"], J = {
  key: 1,
  class: "puik-modal__dialogPanelContainer__dialogPanel__footer puik-scrollbar"
}, b = 24, at = /* @__PURE__ */ w({
  name: "PuikModal",
  __name: "modal",
  props: {
    title: { type: String },
    titleIcon: { type: String },
    mainButtonText: { type: String },
    secondButtonText: { type: String },
    sideButtonText: { type: String },
    isOpen: { type: Boolean },
    isMainButtonDisabled: { type: Boolean },
    variant: { default: l.Feedback, type: null },
    size: { default: Z.Small, type: null },
    dataTest: { type: String }
  },
  emits: W,
  setup($, { emit: D }) {
    const o = $, S = D, E = m(() => l.Destructive === o.variant ? j : o.titleIcon), { width: I } = F(), r = c(null), f = c(!1);
    z(I, async () => {
      await M(), r != null && r.value && (f.value = U(r.value));
    });
    const N = m(() => l.Destructive === o.variant ? "destructive" : "primary"), V = m(() => l.Destructive === o.variant ? "tertiary" : "secondary"), P = () => {
      if (l.Dialog !== o.variant)
        return S("close");
    }, T = m(() => o.mainButtonText || o.secondButtonText || o.sideButtonText);
    return (t, e) => (i(), d(a(O), {
      open: t.isOpen,
      class: B(["puik-modal", [`puik-modal--${t.variant}`, `puik-modal--${t.size}`]]),
      "data-test": t.dataTest,
      onClose: e[4] || (e[4] = (_) => P())
    }, {
      default: n(() => [
        p("div", q, [
          g(a(A), {
            tabindex: "0",
            class: "puik-modal__dialogPanelContainer__dialogPanel"
          }, {
            default: n(() => [
              t.title ? (i(), C("header", G, [
                t.titleIcon || a(l).Destructive === t.variant ? (i(), d(a(y), {
                  key: 0,
                  class: "puik-modal__dialogPanelContainer__dialogPanel__header__icon",
                  icon: E.value ?? "",
                  "font-size": b
                }, null, 8, ["icon"])) : s("", !0),
                g(a(R), {
                  "is-disabled": !f.value,
                  class: "puik-modal__dialogPanelContainer__dialogPanel__header__title"
                }, {
                  description: n(() => [
                    v(u(t.title), 1)
                  ]),
                  default: n(() => [
                    p("h2", {
                      ref_key: "modalTitleElem",
                      ref: r,
                      class: "title",
                      "data-test": t.dataTest != null ? `title-${t.dataTest}` : void 0
                    }, u(t.title), 9, H)
                  ]),
                  _: 1
                }, 8, ["is-disabled"]),
                a(l).Dialog !== t.variant ? (i(), d(a(k), {
                  key: 1,
                  class: "puik-modal__dialogPanelContainer__dialogPanel__header__close-button",
                  variant: "text",
                  "data-test": t.dataTest != null ? `closeButton-${t.dataTest}` : void 0,
                  onClick: e[0] || (e[0] = (_) => P())
                }, {
                  default: n(() => [
                    g(a(y), {
                      icon: "close",
                      "font-size": b
                    })
                  ]),
                  _: 1
                }, 8, ["data-test"])) : s("", !0)
              ])) : s("", !0),
              p("div", {
                class: B([
                  "puik-modal__dialogPanelContainer__dialogPanel__content",
                  "puik-scrollbar",
                  {
                    "puik-modal__dialogPanelContainer__dialogPanel__content--with-footer": T.value
                  }
                ])
              }, [
                h(t.$slots, "default")
              ], 2),
              T.value ? (i(), C("footer", J, [
                a(l).Dialog === t.variant && t.sideButtonText ? (i(), d(a(k), {
                  key: 0,
                  class: "puik-modal__dialogPanelContainer__dialogPanel__footer__button--side",
                  variant: "text",
                  "data-test": t.dataTest != null ? `sideButton-${t.dataTest}` : void 0,
                  onClick: e[1] || (e[1] = (_) => t.$emit("button-side"))
                }, {
                  default: n(() => [
                    v(u(t.sideButtonText), 1)
                  ]),
                  _: 1
                }, 8, ["data-test"])) : s("", !0),
                e[5] || (e[5] = p("span", { class: "puik-modal__dialogPanelContainer__dialogPanel__footer__spacer" }, null, -1)),
                t.secondButtonText ? (i(), d(a(k), {
                  key: 1,
                  class: "puik-modal__dialogPanelContainer__dialogPanel__footer__button--second",
                  variant: V.value,
                  "data-test": t.dataTest != null ? `secondButton-${t.dataTest}` : void 0,
                  onClick: e[2] || (e[2] = (_) => t.$emit("button-second"))
                }, {
                  default: n(() => [
                    v(u(t.secondButtonText), 1)
                  ]),
                  _: 1
                }, 8, ["variant", "data-test"])) : s("", !0),
                t.mainButtonText ? (i(), d(a(k), {
                  key: 2,
                  class: "puik-modal__dialogPanelContainer__dialogPanel__footer__button--main",
                  variant: N.value,
                  disabled: t.isMainButtonDisabled,
                  "data-test": t.dataTest != null ? `mainButton-${t.dataTest}` : void 0,
                  onClick: e[3] || (e[3] = (_) => t.$emit("button-main"))
                }, {
                  default: n(() => [
                    v(u(t.mainButtonText), 1)
                  ]),
                  _: 1
                }, 8, ["variant", "disabled", "data-test"])) : s("", !0)
              ])) : s("", !0)
            ]),
            _: 3
          })
        ])
      ]),
      _: 3
    }, 8, ["open", "class", "data-test"]));
  }
});
export {
  at as default
};
