import { defineComponent as C, ref as _, createElementBlock as u, openBlock as o, Fragment as v, createCommentVNode as P, createElementVNode as g, createBlock as m, toDisplayString as p, createVNode as f, unref as i, withCtx as r, renderList as $, createTextVNode as T, isRef as j } from "vue";
import { useVModel as L } from "@vueuse/core";
import { PuikSelect as B, PuikOption as S } from "../../select/index.mjs";
import { PuikButton as V } from "../../button/index.mjs";
import { useLocale as w } from "../../locale/hooks/use-locale.mjs";
const N = ["data-test"], R = { class: "puik-pagination__content" }, D = { class: "puik-pagination__previous-button-text" }, E = { class: "puik-pagination__jumper" }, U = { class: "puik-pagination__jumper-description" }, A = { class: "puik-pagination__next-button-text" }, F = {
  key: 1,
  class: "puik-pagination__items-per-page-label"
}, H = /* @__PURE__ */ C({
  name: "PuikPaginationLarge",
  __name: "pagination-large",
  props: {
    id: { type: String },
    page: { type: Number },
    itemsPerPage: { type: Number },
    itemsPerPageOptions: { type: Array },
    disabled: { type: Boolean },
    totalItem: { type: Number },
    maxPage: { type: Number },
    label: { type: String },
    dataTest: { type: String },
    displayItemsPerPage: { type: Boolean },
    displayResults: { type: Boolean }
  },
  emits: ["update:page", "update:itemsPerPage"],
  setup(I, { emit: O }) {
    const k = I, l = O, n = L(k, "itemsPerPage", l), { t: d } = w(), b = _(!1), y = _(!1);
    return (e, t) => (o(), u(v, null, [
      e.displayResults ? (o(), u("span", {
        key: 0,
        class: "puik-pagination__label",
        "data-test": e.dataTest != null ? `label-${e.dataTest}` : void 0
      }, p(e.label), 9, N)) : P("", !0),
      g("div", R, [
        f(i(V), {
          "aria-label": i(d)("puik.pagination.previous", { page: e.page - 1 }),
          disabled: e.page <= 1 || e.disabled,
          class: "puik-pagination__previous-button puik-pagination__button",
          "left-icon": "keyboard_arrow_left",
          variant: "tertiary",
          "data-test": e.dataTest != null ? `previousButton-${e.dataTest}` : void 0,
          onClick: t[0] || (t[0] = (a) => l("update:page", e.page - 1))
        }, {
          default: r(() => [
            g("span", D, p(i(d)("puik.pagination.previous")), 1)
          ]),
          _: 1
        }, 8, ["aria-label", "disabled", "data-test"]),
        g("div", E, [
          (o(), m(i(B), {
            id: `${k.id}__select-jumper`,
            key: e.page,
            "model-value": e.page,
            disabled: e.disabled,
            "data-test": e.dataTest != null ? `pageSelector-${e.dataTest}` : void 0,
            class: "puik-pagination__select",
            open: b.value,
            "onUpdate:modelValue": t[3] || (t[3] = (a) => l("update:page", a))
          }, {
            default: r(() => [
              (o(!0), u(v, null, $(e.maxPage, (a) => (o(), m(i(S), {
                key: `puik-pagination__page-selector__option-${a}`,
                label: a,
                value: a,
                "is-selected": e.page === a,
                "data-test": e.dataTest != null ? `pageSelectorOption-${e.dataTest}-${a}` : void 0,
                onSelect: t[1] || (t[1] = (s) => l("update:page", s.value)),
                onOpen: t[2] || (t[2] = (s) => b.value = s)
              }, {
                default: r(() => [
                  T(p(a), 1)
                ]),
                _: 2
              }, 1032, ["label", "value", "is-selected", "data-test"]))), 128))
            ]),
            _: 1
          }, 8, ["id", "model-value", "disabled", "data-test", "open"])),
          g("span", U, p(i(d)("puik.pagination.large.jumperDescription", { maxPage: e.maxPage })), 1)
        ]),
        f(i(V), {
          "aria-label": i(d)("puik.pagination.next", { page: e.page + 1 }),
          disabled: e.page >= e.maxPage || e.disabled,
          class: "puik-pagination__button puik-pagination__next-button",
          "right-icon": "keyboard_arrow_right",
          variant: "tertiary",
          "data-test": e.dataTest != null ? `nextButton-${e.dataTest}` : void 0,
          onClick: t[4] || (t[4] = (a) => l("update:page", e.page + 1))
        }, {
          default: r(() => [
            g("span", A, p(i(d)("puik.pagination.next")), 1)
          ]),
          _: 1
        }, 8, ["aria-label", "disabled", "data-test"])
      ]),
      e.displayItemsPerPage ? (o(), u("span", F, p(i(d)("puik.pagination.itemPerPageLabel", { maxPage: e.maxPage })), 1)) : P("", !0),
      e.displayItemsPerPage ? (o(), m(i(B), {
        id: `${k.id}__select-items-per-page`,
        key: i(n),
        modelValue: i(n),
        "onUpdate:modelValue": [
          t[7] || (t[7] = (a) => j(n) ? n.value = a : null),
          t[8] || (t[8] = (a) => l("update:itemsPerPage", i(n)))
        ],
        class: "puik-pagination__items-per-page-select",
        open: y.value
      }, {
        default: r(() => [
          (o(!0), u(v, null, $(e.itemsPerPageOptions, (a) => (o(), m(i(S), {
            key: `puik-pagination__items-per-page-select__option-${a}`,
            label: a,
            value: a,
            "is-selected": i(n) === a,
            class: "puik-pagination__items-per-page-select__option",
            onSelect: t[5] || (t[5] = (s) => n.value = s.value),
            onOpen: t[6] || (t[6] = (s) => y.value = s)
          }, {
            default: r(() => [
              T(p(a), 1)
            ]),
            _: 2
          }, 1032, ["label", "value", "is-selected"]))), 128))
        ]),
        _: 1
      }, 8, ["id", "modelValue", "open"])) : P("", !0)
    ], 64));
  }
});
export {
  H as default
};
