import { defineComponent as B, computed as s, watch as L, createElementBlock as k, openBlock as r, unref as u, normalizeClass as T, createBlock as n, createCommentVNode as g, mergeProps as v } from "vue";
import { generateId as M } from "../../utils/rand.mjs";
import { useLocale as S } from "../../locale/hooks/use-locale.mjs";
import { PuikPaginationVariants as o } from "./pagination.mjs";
import U from "./pagination-loader.vue2.mjs";
import C from "./pagination-mobile.vue2.mjs";
import N from "./pagination-small.vue2.mjs";
import R from "./pagination-medium.vue2.mjs";
import w from "./pagination-large.vue2.mjs";
const O = ["id", "aria-label", "data-test"], z = {
  key: 1,
  class: "puik-pagination__content"
}, K = /* @__PURE__ */ B({
  name: "PuikPagination",
  __name: "pagination",
  props: {
    id: { default: `puik-pagination-${M()}`, type: String },
    variant: { default: o.Medium, type: null },
    totalItem: { type: Number },
    itemsPerPage: { default: 5, type: Number },
    itemsPerPageOptions: { default: () => [5, 10, 15], type: Array },
    displayItemsPerPage: { type: Boolean, default: !0 },
    displayResults: { type: Boolean, default: !0 },
    page: { type: Number },
    label: { type: String },
    loaderButtonLabel: { type: String },
    dataTest: { type: String }
  },
  emits: ["update:page", "update:itemsPerPage"],
  setup(I, { emit: V }) {
    const a = I, P = V, { t: m } = S(), t = s({
      get: () => a.page,
      set: (e) => P("update:page", e)
    }), y = s(() => a.page * a.itemsPerPage), $ = s(() => y.value === a.totalItem), d = s(() => Math.ceil(a.totalItem / a.itemsPerPage)), b = s(() => !a.totalItem || !d.value), f = s(() => {
      if (a.label) return a.label;
      const e = `puik.pagination.${a.variant}.label`;
      switch (a.variant) {
        case o.Mobile:
        case o.Small:
          return m(e, {
            page: t.value,
            maxPage: d.value,
            totalItem: a.totalItem
          });
        case o.Medium:
        case o.Large:
          return m(e, {
            totalItem: a.totalItem
          });
        default:
          return m(e, {
            itemCount: y.value,
            totalItem: a.totalItem
          });
      }
    }), p = s(() => ({
      label: f.value,
      maxPage: d.value,
      disabled: b.value
    }));
    return L(() => a.itemsPerPage, () => {
      t.value > d.value && (t.value = d.value);
    }), (e, l) => (r(), k("nav", {
      id: a.id,
      class: T(["puik-pagination", [`puik-pagination--${e.variant}`]]),
      role: "navigation",
      "aria-label": u(m)("puik.pagination.ariaLabel"),
      "data-test": e.dataTest
    }, [
      e.variant === u(o).Loader ? (r(), n(U, {
        key: 0,
        id: `${a.id}--loader`,
        modelValue: t.value,
        "onUpdate:modelValue": l[0] || (l[0] = (i) => t.value = i),
        "data-test": e.dataTest,
        disabled: $.value,
        label: f.value,
        "loader-button-label": e.loaderButtonLabel
      }, null, 8, ["id", "modelValue", "data-test", "disabled", "label", "loader-button-label"])) : (r(), k("div", z, [
        e.variant === u(o).Mobile ? (r(), n(C, v({
          key: 0,
          id: `${a.id}--mobile`,
          modelValue: t.value,
          "onUpdate:modelValue": l[1] || (l[1] = (i) => t.value = i)
        }, p.value, { "data-test": e.dataTest }), null, 16, ["id", "modelValue", "data-test"])) : g("", !0),
        e.variant === u(o).Small ? (r(), n(N, v({
          key: 1,
          id: `${a.id}--small`,
          modelValue: t.value,
          "onUpdate:modelValue": l[2] || (l[2] = (i) => t.value = i)
        }, p.value, {
          "data-test": e.dataTest,
          "display-results": e.displayResults
        }), null, 16, ["id", "modelValue", "data-test", "display-results"])) : g("", !0),
        e.variant === u(o).Medium && !b.value ? (r(), n(R, v({
          key: 2,
          id: `${a.id}--medium`,
          modelValue: t.value,
          "onUpdate:modelValue": l[3] || (l[3] = (i) => t.value = i)
        }, p.value, {
          "data-test": e.dataTest,
          "display-results": e.displayResults,
          "total-item": e.totalItem
        }), null, 16, ["id", "modelValue", "data-test", "display-results", "total-item"])) : g("", !0),
        e.variant === u(o).Large ? (r(), n(w, v({
          key: 3,
          id: `${a.id}--large`,
          page: t.value,
          "onUpdate:page": l[4] || (l[4] = (i) => t.value = i),
          "data-test": e.dataTest,
          "display-items-per-page": e.displayItemsPerPage,
          "display-results": e.displayResults,
          "items-per-page": e.itemsPerPage,
          "items-per-page-options": e.itemsPerPageOptions,
          "total-item": e.totalItem
        }, p.value, {
          "onUpdate:itemsPerPage": l[5] || (l[5] = (i) => P("update:itemsPerPage", i))
        }), null, 16, ["id", "page", "data-test", "display-items-per-page", "display-results", "items-per-page", "items-per-page-options", "total-item"])) : g("", !0)
      ]))
    ], 10, O));
  }
});
export {
  K as default
};
