import { defineComponent as ae, useSlots as ie, computed as z, ref as f, watch as M, withDirectives as j, createElementBlock as h, openBlock as r, withKeys as p, normalizeClass as N, withModifiers as s, createElementVNode as I, createCommentVNode as _, createBlock as k, unref as a, withCtx as w, createTextVNode as G, toDisplayString as U, Fragment as D, mergeProps as A, createVNode as v, renderList as H, createSlots as F, normalizeStyle as de, renderSlot as W, vShow as se, nextTick as ne } from "vue";
import { vOnClickOutside as re } from "@vueuse/components";
import { useLocale as pe } from "../../locale/hooks/use-locale.mjs";
import "../../config-provider/src/config-provider.mjs";
import "../../button/src/button.vue2.mjs";
import { PuikInput as L } from "../../input/index.mjs";
import "../../alert/src/alert.vue2.mjs";
import "../../tooltip/src/tooltip.vue2.mjs";
import "@headlessui/vue";
import { PuikCheckbox as ue } from "../../checkbox/index.mjs";
import { PuikLabel as ce } from "../../label/index.mjs";
import "@vueuse/core";
import { slotIsEmpty as me } from "../../utils/types.mjs";
import { isDropdownBelowViewport as ve } from "../../utils/isDropdownBelowViewport.mjs";
import "../../link/src/link.vue2.mjs";
import "../../card/src/card.vue2.mjs";
import { PuikOption as be } from "../index.mjs";
import { PuikIcon as b } from "../../icon/index.mjs";
import "../../pagination/src/pagination.vue2.mjs";
import "../../badge/src/badge.vue2.mjs";
import "../../skeleton-loader/src/skeleton-loader.vue2.mjs";
import "../../modal/src/modal.vue2.mjs";
import "../../snackbar/src/snackbar.vue2.mjs";
import "../../snackbar/src/snackbar-provider.vue2.mjs";
import "../../table/src/table-search-input.vue2.mjs";
import "../../spinner-loader/src/spinner-loader.vue2.mjs";
import "../../menu/src/menu.vue2.mjs";
import { PuikChip as ye } from "../../chip/index.mjs";
import "../../tag/src/tag.vue2.mjs";
import "../../avatar/src/avatar.vue2.mjs";
import "../../divider/src/divider.vue2.mjs";
import "../../notification-bar/src/notification-bar.vue2.mjs";
import "../../sortable-list/src/sortable-list.vue2.mjs";
import "../../rating-card/src/rating-card.vue2.mjs";
const fe = ["data-test", "onKeydown"], he = ["id", "autocomplete", "aria-expanded", "value", "data-test", "onKeydown"], ke = { class: "puik-multi-select__options-tags--container" }, we = ["id", "name", "value"], ge = ["id", "aria-multiselectable", "data-test"], Se = {
  key: 0,
  class: "puik-select__no-results"
}, Ke = ["data-test"], _e = { class: "puik-select__error__text" }, dt = /* @__PURE__ */ ae({
  name: "PuikSelect",
  __name: "select",
  props: {
    modelValue: { type: null },
    open: { type: Boolean, default: !1 },
    id: { type: String },
    name: { type: String },
    label: { type: String },
    required: { type: Boolean, default: !1 },
    optional: { type: Boolean, default: !1 },
    options: { type: Array },
    optionLabelKey: { default: "label", type: String },
    optionValueKey: { default: "value", type: String },
    optionDisabledKey: { default: "disabled", type: String },
    multiSelect: { type: Boolean, default: !1 },
    searchable: { type: Boolean },
    customFilterMethod: { type: Function },
    placeholder: { type: String },
    searchPlaceholder: { type: String },
    noMatchText: { type: String },
    disabled: { type: Boolean },
    error: { type: String },
    autocomplete: { default: "off", type: String },
    prependInputIcon: { type: String },
    zIndex: { default: 10, type: Number },
    dataTest: { type: String }
  },
  emits: ["open", "update:modelValue", "search"],
  setup(X, { emit: Y }) {
    const Z = ie(), { t: g } = pe(), e = X, y = Y, $ = z(() => e.error || me(Z.error)), i = f(
      Array.isArray(e.modelValue) ? [...e.modelValue] : []
    ), c = f(e.modelValue), n = f(e.open), K = f(""), R = f(!1), P = f(!1), x = () => {
      ne(() => {
        const t = document.querySelector(`#${e.id}`), l = document.querySelector(`#dropdown-${e.id}`);
        l && t && n.value && (ve(t, l) ? P.value = !0 : P.value = !1);
      });
    }, B = z(() => {
      if (e.customFilterMethod)
        return e.customFilterMethod(K.value);
      if (e.options) {
        const t = K.value.toLowerCase();
        return e.options.filter((l) => {
          var d;
          const o = (d = l == null ? void 0 : l[e.optionLabelKey]) == null ? void 0 : d.toLowerCase();
          return o && t.split("").every((O) => o.includes(O));
        });
      } else
        return null;
    }), ee = () => {
      y("search", K.value, B.value);
    }, T = () => {
      K.value = "", y("search", "", e.options);
    }, J = z(() => e.options ? e.options.length === e.options.filter(
      (t) => !t[e.optionDisabledKey]
    ).length : null), m = f(J.value), V = (t) => {
      if (e.options && Array.isArray(t)) {
        const l = e.options.filter(
          (d) => !d[e.optionDisabledKey]
        ).length, o = t.filter(
          (d) => !d[e.optionDisabledKey]
        ).length;
        R.value = o > 0 && o < l, m.value = o === l;
      }
    }, E = () => {
      var t;
      if (e.options) {
        const l = (t = i.value) == null ? void 0 : t.filter(
          (d) => d[e.optionDisabledKey]
        ), o = e.options.filter(
          (d) => !d[e.optionDisabledKey]
        );
        m.value ? i.value = [...l] : i.value = [...o, ...l], V(i.value), y("update:modelValue", i.value);
      }
    }, te = () => {
      m.value = !m.value, E();
    }, u = () => {
      e.disabled || (n.value = !n.value, y("open", n.value), T(), x());
    }, q = () => {
      e.disabled || (n.value = !0, y("open", !0), T(), x());
    }, C = () => {
      e.disabled || (n.value = !1, y("open", !1), T(), x());
    }, le = (t) => {
      (!t[e.optionDisabledKey] || !e.disabled) && (e.multiSelect ? (i.value.includes(t) ? i.value = i.value.filter(
        (l) => l !== t
      ) : i.value.push(t), V(i.value), y("update:modelValue", i.value)) : (u(), c.value !== t ? c.value = t : c.value = {}, y("update:modelValue", c.value)));
    }, oe = (t) => {
      e.disabled || (i.value = i.value.filter(
        (l) => l !== t
      ), V(i.value), y("update:modelValue", i.value));
    }, S = f(-1), Q = (t) => {
      const l = document.querySelectorAll(`#dropdown-${e.id} .puik-option:not(.puik-option--disabled)`), o = document.activeElement;
      S.value = Array.from(l).indexOf(o), t.key === "ArrowDown" && (t.preventDefault(), S.value = (S.value + 1) % l.length, l[S.value].focus()), t.key === "ArrowUp" && (t.preventDefault(), S.value = (S.value - 1 + l.length) % l.length, l[S.value].focus());
    };
    return M(J, (t) => {
      m.value = t;
    }), M(
      () => e.modelValue,
      (t) => {
        c.value = t, V(t);
      }
    ), M(
      () => e.open,
      (t) => {
        console.log("watch open prop"), n.value = t;
      }
    ), V(i.value), (t, l) => j((r(), h("div", {
      class: N([
        "puik-select",
        { "puik-select--disabled": e.disabled }
      ]),
      "data-test": t.dataTest != null ? `select-${t.dataTest}` : void 0,
      onKeydown: [
        p(C, ["esc"]),
        p(s(Q, ["prevent", "stop"]), ["up"]),
        p(s(Q, ["prevent", "stop"]), ["down"])
      ]
    }, [
      I("div", {
        class: N([
          "puik-select__container",
          { "puik-select__container--error": $.value }
        ])
      }, [
        e.id && e.label ? (r(), k(a(ce), {
          key: 0,
          class: "puik-select__label",
          for: e.id,
          required: e.required,
          optional: e.optional,
          readonly: e.disabled,
          "data-test": t.dataTest != null ? `select-label-${t.dataTest}` : void 0,
          onClick: T
        }, {
          default: w(() => [
            G(U(e.label), 1)
          ]),
          _: 1
        }, 8, ["for", "required", "optional", "readonly", "data-test"])) : _("", !0),
        e.multiSelect && e.options ? (r(), h(D, { key: 1 }, [
          i.value.length > 0 ? (r(), h("button", A({
            key: 0,
            id: e.id,
            class: ["puik-multi-select__options-tags--button"],
            autocomplete: e.autocomplete,
            role: "combobox",
            "aria-expanded": n.value
          }, n.value ? { "aria-controls": `dropdown-${e.id}` } : {}, {
            "aria-haspopup": "listbox",
            value: JSON.stringify(i.value),
            "data-test": t.dataTest != null ? `select-multiple-options-tags-${t.dataTest}` : void 0,
            onClick: s(u, ["stop"]),
            onKeydown: [
              p(s(u, ["prevent", "stop"]), ["space"]),
              p(s(u, ["prevent", "stop"]), ["enter"])
            ]
          }), [
            e.prependInputIcon ? (r(), k(a(b), {
              key: 0,
              "is-disabled": e.disabled,
              icon: e.prependInputIcon
            }, null, 8, ["is-disabled", "icon"])) : _("", !0),
            v(a(b), {
              class: "puik-multi-select__dropdown-icon",
              "is-disabled": e.disabled,
              icon: "unfold_more"
            }, null, 8, ["is-disabled"]),
            I("div", ke, [
              (r(!0), h(D, null, H(i.value, (o, d) => (r(), k(a(ye), {
                id: `chip-${o[e.optionLabelKey]}`,
                key: o[e.optionValueKey],
                content: o[e.optionLabelKey],
                disabled: o[e.optionDisabledKey] || e.disabled,
                size: "small",
                role: "option",
                "aria-selected": !0,
                "data-test": t.dataTest != null ? `select-tag-${d + 1}-${t.dataTest}` : void 0,
                onClose: (O) => oe(o),
                onClick: s(q, ["stop"]),
                onKeydown: [
                  p(s(q, ["stop"]), ["space"]),
                  p(s(q, ["stop"]), ["enter"])
                ]
              }, null, 8, ["id", "content", "disabled", "data-test", "onClose", "onKeydown"]))), 128))
            ])
          ], 16, he)) : (r(), h(D, { key: 1 }, [
            v(a(L), A({
              id: e.id,
              name: e.name ?? e.id,
              class: [
                "puik-multi-select__input",
                { "puik-multi-select__input--error": $.value }
              ],
              type: "text",
              placeholder: e.placeholder ?? `${a(g)("puik.select.placeholder")}`,
              readonly: "",
              autocomplete: e.autocomplete,
              disabled: e.disabled,
              role: "combobox",
              "aria-expanded": n.value
            }, n.value ? { "aria-controls": `dropdown-${e.id}` } : {}, {
              "aria-haspopup": "listbox",
              "data-test": t.dataTest != null ? `select-multiple-input-${t.dataTest}` : void 0,
              onClick: s(u, ["stop"]),
              onKeydown: [
                p(s(u, ["prevent", "stop"]), ["space"]),
                p(s(u, ["prevent", "stop"]), ["enter"])
              ]
            }), F({
              append: w(() => [
                v(a(b), {
                  "is-disabled": e.disabled,
                  icon: "unfold_more"
                }, null, 8, ["is-disabled"])
              ]),
              _: 2
            }, [
              e.prependInputIcon ? {
                name: "prepend",
                fn: w(() => [
                  v(a(b), {
                    "is-disabled": e.disabled,
                    icon: e.prependInputIcon
                  }, null, 8, ["is-disabled", "icon"])
                ]),
                key: "0"
              } : void 0
            ]), 1040, ["id", "name", "class", "placeholder", "autocomplete", "disabled", "aria-expanded", "data-test", "onKeydown"]),
            I("input", {
              id: `hidden-${e.id}`,
              type: "hidden",
              name: e.name ?? e.id,
              value: JSON.stringify(i.value)
            }, null, 8, we)
          ], 64))
        ], 64)) : e.options && typeof c.value == "object" ? (r(), k(a(L), A({
          key: 2,
          id: e.id,
          modelValue: c.value[t.optionLabelKey],
          "onUpdate:modelValue": l[0] || (l[0] = (o) => c.value[t.optionLabelKey] = o),
          name: e.name ?? e.id,
          class: [
            "puik-single-select__input",
            { "puik-single-select__input--error": $.value }
          ],
          type: "text",
          placeholder: e.placeholder ?? `${a(g)("puik.select.placeholder")}`,
          readonly: "",
          autocomplete: e.autocomplete,
          disabled: e.disabled,
          role: "combobox",
          "aria-expanded": n.value
        }, n.value ? { "aria-controls": `dropdown-${e.id}` } : {}, {
          "aria-haspopup": "listbox",
          "data-test": t.dataTest != null ? `select-single-${t.dataTest}` : void 0,
          onClick: s(u, ["stop"]),
          onKeydown: [
            p(s(u, ["prevent", "stop"]), ["space"]),
            p(s(u, ["prevent", "stop"]), ["enter"])
          ]
        }), F({
          append: w(() => [
            v(a(b), {
              "is-disabled": e.disabled,
              icon: "unfold_more"
            }, null, 8, ["is-disabled"])
          ]),
          _: 2
        }, [
          e.prependInputIcon ? {
            name: "prepend",
            fn: w(() => [
              v(a(b), {
                "is-disabled": e.disabled,
                icon: e.prependInputIcon
              }, null, 8, ["is-disabled", "icon"])
            ]),
            key: "0"
          } : void 0
        ]), 1040, ["id", "modelValue", "name", "class", "placeholder", "autocomplete", "disabled", "aria-expanded", "data-test", "onKeydown"])) : (r(), k(a(L), A({
          key: 3,
          id: e.id,
          modelValue: c.value,
          "onUpdate:modelValue": l[1] || (l[1] = (o) => c.value = o),
          name: e.name ?? e.id,
          class: [
            "puik-single-select__input",
            { "puik-single-select__input--error": $.value }
          ],
          type: "text",
          placeholder: e.placeholder ?? `${a(g)("puik.select.placeholder")}`,
          readonly: "",
          autocomplete: e.autocomplete,
          disabled: e.disabled,
          role: "combobox",
          "aria-expanded": n.value
        }, n.value ? { "aria-controls": `dropdown-${e.id}` } : {}, {
          "data-test": t.dataTest != null ? `select-single-${t.dataTest}` : void 0,
          "aria-haspopup": "listbox",
          onClick: s(u, ["stop"]),
          onKeydown: [
            p(s(u, ["prevent", "stop"]), ["space"]),
            p(s(u, ["prevent", "stop"]), ["enter"])
          ]
        }), F({
          append: w(() => [
            v(a(b), {
              "is-disabled": e.disabled,
              icon: "unfold_more"
            }, null, 8, ["is-disabled"])
          ]),
          _: 2
        }, [
          e.prependInputIcon ? {
            name: "prepend",
            fn: w(() => [
              v(a(b), {
                "is-disabled": e.disabled,
                icon: e.prependInputIcon
              }, null, 8, ["is-disabled", "icon"])
            ]),
            key: "0"
          } : void 0
        ]), 1040, ["id", "modelValue", "name", "class", "placeholder", "autocomplete", "disabled", "aria-expanded", "data-test", "onKeydown"])),
        j(I("div", {
          id: `dropdown-${e.id}`,
          style: de({ "z-index": e.zIndex }),
          class: N([
            "puik-select-dropdown",
            { "puik-select-dropdown--up": P.value }
          ]),
          role: "listbox",
          "aria-multiselectable": e.multiSelect,
          "data-test": t.dataTest != null ? `select-dropdown-${t.dataTest}` : void 0,
          onKeydown: p(C, ["tab"])
        }, [
          t.searchable ? (r(), k(a(L), {
            key: 0,
            modelValue: K.value,
            "onUpdate:modelValue": l[2] || (l[2] = (o) => K.value = o),
            class: "puik-select-dropdown__search-input",
            type: "text",
            placeholder: e.searchPlaceholder ?? `${a(g)("puik.select.searchPlaceholder")}`,
            role: "searchbox",
            disabled: e.disabled,
            "data-test": t.dataTest != null ? `select-search-input-${t.dataTest}` : void 0,
            onInput: ee
          }, {
            prepend: w(() => [
              v(a(b), {
                "is-disabled": e.disabled,
                icon: "search"
              }, null, 8, ["is-disabled"])
            ]),
            _: 1
          }, 8, ["modelValue", "placeholder", "disabled", "data-test"])) : _("", !0),
          e.multiSelect && typeof m.value == "boolean" ? (r(), k(a(ue), {
            key: 1,
            modelValue: m.value,
            "onUpdate:modelValue": l[3] || (l[3] = (o) => m.value = o),
            class: "puik-option puik-select-dropdown__select-all",
            label: m.value ? `${a(g)("puik.select.deselectAll")}` : `${a(g)("puik.select.selectAll")}`,
            indeterminate: R.value,
            disabled: e.disabled,
            role: "checkbox",
            "aria-checked": m.value,
            tabindex: "0",
            onChange: te,
            onKeydown: [
              p(s(E, ["prevent"]), ["enter"]),
              p(s(E, ["prevent"]), ["space"])
            ]
          }, null, 8, ["modelValue", "label", "indeterminate", "disabled", "aria-checked", "onKeydown"])) : _("", !0),
          W(t.$slots, "default", {}, () => {
            var o;
            return [
              (r(!0), h(D, null, H(B.value, (d, O) => (r(), k(a(be), {
                key: d[e.optionValueKey],
                label: d[e.optionLabelKey],
                value: d[e.optionValueKey],
                "is-selected": e.multiSelect ? i.value.includes(d) : c.value === d,
                option: d,
                disabled: d[e.optionDisabledKey] || e.disabled,
                "multi-select": e.multiSelect,
                "data-test": t.dataTest != null ? `select-option-${O + 1}-${t.dataTest}` : void 0,
                onSelect: ($e) => le(d),
                onClose: C
              }, null, 8, ["label", "value", "is-selected", "option", "disabled", "multi-select", "data-test", "onSelect"]))), 128)),
              (o = B.value) != null && o.length ? _("", !0) : (r(), h("div", Se, U(e.noMatchText ?? `${a(g)("puik.select.noResults")}`), 1))
            ];
          })
        ], 46, ge), [
          [se, n.value]
        ])
      ], 2),
      $.value ? (r(), h("div", {
        key: 0,
        class: "puik-select__error",
        "data-test": t.dataTest != null ? `select-error-${t.dataTest}` : void 0
      }, [
        v(a(b), {
          icon: "error",
          "font-size": "1.25rem",
          class: "puik-select__error__icon"
        }),
        I("span", _e, [
          W(t.$slots, "error", {}, () => [
            G(U(t.error), 1)
          ])
        ])
      ], 8, Ke)) : _("", !0)
    ], 42, fe)), [
      [a(re), C]
    ]);
  }
});
export {
  dt as default
};
