import { defineComponent as f, createBlock as a, openBlock as r, unref as o, mergeProps as b, withCtx as e, createElementVNode as y, createVNode as n, createCommentVNode as s, createTextVNode as m, toDisplayString as l, renderSlot as g } from "vue";
import { useForwardPropsEmits as C, ToastRoot as h, ToastTitle as S, ToastDescription as w, ToastAction as T, ToastClose as B } from "radix-vue";
import "../../config-provider/src/config-provider.mjs";
import "../../button/src/button.vue2.mjs";
import "../../input/src/input.vue2.mjs";
import "../../alert/src/alert.vue2.mjs";
import "../../tooltip/src/tooltip.vue2.mjs";
import "@headlessui/vue";
import { generateId as P } from "../../utils/rand.mjs";
import "@vueuse/core";
import "../../link/src/link.vue2.mjs";
import "../../card/src/card.vue2.mjs";
import "@vueuse/components";
import { PuikIcon as N } from "../../icon/index.mjs";
import "../../pagination/src/pagination.vue2.mjs";
import "../../badge/src/badge.vue2.mjs";
import "../../skeleton-loader/src/skeleton-loader.vue2.mjs";
import "../../modal/src/modal.vue2.mjs";
import "./snackbar-provider.vue2.mjs";
import { PuikSnackbarSwipeAnimations as V, PuikSnackbarVariants as A } from "./snackbar.mjs";
import "../../table/src/table-search-input.vue2.mjs";
import "../../spinner-loader/src/spinner-loader.vue2.mjs";
import "../../menu/src/menu.vue2.mjs";
import "../../chip/src/chip.vue2.mjs";
import "../../tag/src/tag.vue2.mjs";
import "../../avatar/src/avatar.vue2.mjs";
import "../../divider/src/divider.vue2.mjs";
import "../../notification-bar/src/notification-bar.vue2.mjs";
import "../../sortable-list/src/sortable-list.vue2.mjs";
import "../../rating-card/src/rating-card.vue2.mjs";
const O = { class: "puik-snackbar-message" }, pt = /* @__PURE__ */ f({
  name: "PuikSnackbar",
  __name: "snackbar",
  props: {
    id: { default: `puik-snackbar-${P()}`, type: String },
    open: { type: Boolean },
    title: { type: String },
    description: { type: String },
    duration: { type: Number },
    variant: { default: A.Default, type: null },
    swipeAnimation: { default: V.Right, type: null },
    hasCloseButton: { type: Boolean },
    action: { type: [Object, Function] },
    onOpenChange: { type: Function }
  },
  emits: ["update:open"],
  setup(c, { emit: u }) {
    const i = c, d = C(i, u);
    return (t, p) => (r(), a(o(h), b(o(d), {
      class: ["puik-snackbar-root", `puik-snackbar-root--${t.variant}`, `puik-snackbar-root--swipe-${t.swipeAnimation}`],
      "onUpdate:open": p[0] || (p[0] = (k) => {
        i.onOpenChange && i.onOpenChange(k);
      })
    }), {
      default: e(() => [
        y("div", O, [
          t.title ? (r(), a(o(S), {
            key: 0,
            class: "puik-snackbar-title"
          }, {
            default: e(() => [
              m(l(t.title), 1)
            ]),
            _: 1
          })) : s("", !0),
          n(o(w), { class: "puik-snackbar-description" }, {
            default: e(() => [
              m(l(t.description), 1)
            ]),
            _: 1
          })
        ]),
        n(o(T), {
          class: "puik-snackbar-action",
          "as-child": "",
          "alt-text": "alt-text"
        }, {
          default: e(() => [
            g(t.$slots, "action")
          ]),
          _: 3
        }),
        t.hasCloseButton ? (r(), a(o(B), {
          key: 0,
          class: "puik-snackbar-close",
          "aria-label": "Close"
        }, {
          default: e(() => [
            n(o(N), {
              icon: "close",
              "aria-hidden": ""
            })
          ]),
          _: 1
        })) : s("", !0)
      ]),
      _: 3
    }, 16, ["class"]));
  }
});
export {
  pt as default
};
