import { defineComponent as C, ref as _, createElementBlock as c, openBlock as d, createVNode as N, unref as g, withCtx as U, normalizeClass as L, createElementVNode as k, createCommentVNode as u, toDisplayString as S, createBlock as A, renderSlot as B, nextTick as q } from "vue";
import { PuikSortableListTag as E, PuikSortableListIconPosition as $ } from "./sortable-list.mjs";
import "../../config-provider/src/config-provider.mjs";
import "../../button/src/button.vue2.mjs";
import "../../input/src/input.vue2.mjs";
import "../../alert/src/alert.vue2.mjs";
import "../../tooltip/src/tooltip.vue2.mjs";
import "@headlessui/vue";
import "@vueuse/core";
import "../../link/src/link.vue2.mjs";
import "../../card/src/card.vue2.mjs";
import "@vueuse/components";
import { PuikIcon as w } from "../../icon/index.mjs";
import "../../pagination/src/pagination.vue2.mjs";
import "../../badge/src/badge.vue2.mjs";
import "../../skeleton-loader/src/skeleton-loader.vue2.mjs";
import "../../modal/src/modal.vue2.mjs";
import "../../snackbar/src/snackbar.vue2.mjs";
import "../../snackbar/src/snackbar-provider.vue2.mjs";
import "../../table/src/table-search-input.vue2.mjs";
import "../../spinner-loader/src/spinner-loader.vue2.mjs";
import "../../menu/src/menu.vue2.mjs";
import "../../chip/src/chip.vue2.mjs";
import "../../tag/src/tag.vue2.mjs";
import "../../avatar/src/avatar.vue2.mjs";
import "../../divider/src/divider.vue2.mjs";
import "../../notification-bar/src/notification-bar.vue2.mjs";
import "../../rating-card/src/rating-card.vue2.mjs";
import { Sortable as K } from "sortablejs-vue3";
const M = ["id", "data-test"], R = ["data-item", "aria-label", "data-sortable-id", "data-test"], V = { class: "puik-sortable-list_item" }, F = ["data-test"], J = { class: "puik-sortable-list_item-container" }, O = ["src", "data-test"], z = { class: "puik-sortable-list_item-content" }, j = ["data-test"], G = ["data-test"], _t = /* @__PURE__ */ C({
  name: "PuikSortableList",
  __name: "sortable-list",
  props: {
    listId: { type: String },
    list: { type: Array },
    displayPositionNumbers: { type: Boolean, default: !0 },
    iconPosition: { default: $.Right, type: null },
    itemKey: { type: [String, Function] },
    tag: { default: E.Ul, type: null },
    options: { default: { animation: 150 }, type: null },
    dataTest: { type: String }
  },
  emits: ["list-changed", "choose", "unchoose", "start", "end", "add", "update", "sort", "remove", "filter", "move", "clone", "change"],
  setup(v, { expose: I, emit: D }) {
    const l = v, b = D, y = _(null);
    I({
      sortable: y
    });
    const p = _([...l.list]), P = (t, s) => {
      b("move", t, s);
    }, r = (t) => {
      let s;
      if (t.type === "remove" ? s = t.from.children : s = t.to.children, ["add", "remove"].includes(t.type) || t.type === "end" && t.from.children === t.to.children) {
        for (let o = 0; o < s.length; o++) {
          s[o].setAttribute("data-sortable-id", o.toString());
          const n = s[o].querySelector(
            ".puik-sortable-list_item-index"
          );
          n && (n.textContent = (o + 1).toString());
        }
        const e = Array.from(s).map((o) => {
          if (o.hasAttribute("data-item")) {
            const n = o.getAttribute("data-item");
            return n ? JSON.parse(n) : null;
          }
          return null;
        });
        b("list-changed", e);
      }
      b(t.type, t);
    };
    let f = !1;
    const T = (t) => {
      var n;
      if (t.preventDefault(), f = f ?? !0, ((n = l.options) == null ? void 0 : n.group) === "shared" || f) return;
      const s = document.querySelectorAll(`.draggable-${l.listId}`);
      for (let i = 0; i < s.length; i++) {
        s[i].setAttribute("data-sortable-id", i.toString());
        const a = s[i].querySelector(
          ".puik-sortable-list_item-index"
        );
        a && (a.textContent = (i + 1).toString());
      }
      const e = t.target, o = t.key;
      if (e.classList.contains(`draggable-${l.listId}`)) {
        let i = null;
        const a = Number(e.getAttribute("data-sortable-id"));
        if (t.shiftKey && (o === "ArrowUp" || o === "ArrowDown")) {
          if (t.preventDefault(), o === "ArrowUp" && a > 0 ? i = a - 1 : o === "ArrowDown" && a < p.value.length - 1 ? i = a + 1 : i = a, i !== null) {
            const m = p.value[a];
            p.value.splice(a, 1), p.value.splice(i, 0, m), b("list-changed", p.value), q(() => {
              const h = document.querySelector(
                `.draggable-${l.listId}[data-sortable-id="${i}"]`
              );
              h == null || h.focus();
            });
          }
        } else if ((o === "ArrowUp" || o === "ArrowDown") && (t.preventDefault(), o === "ArrowUp" && a > 0 ? i = a - 1 : o === "ArrowDown" && a < p.value.length - 1 ? i = a + 1 : i = a, i !== null)) {
          const m = document.querySelector(
            `.draggable-${l.listId}[data-sortable-id="${i}"]`
          );
          m == null || m.focus();
        }
      }
      f = !1;
    };
    return (t, s) => (d(), c("div", {
      id: t.listId,
      "data-test": t.dataTest
    }, [
      N(g(K), {
        ref: l.listId,
        sortable: y.value,
        "onUpdate:sortable": s[0] || (s[0] = (e) => y.value = e),
        list: p.value,
        "item-key": l.itemKey,
        tag: l.tag,
        options: l.options,
        onChange: r,
        onChoose: r,
        onUnchoose: r,
        onStart: r,
        onEnd: r,
        onAdd: r,
        onUpdate: r,
        onSort: r,
        onRemove: r,
        onFilter: r,
        onMove: P,
        onClone: r,
        onKeydown: s[1] || (s[1] = (e) => T(e))
      }, {
        item: U(({ element: e, index: o }) => [
          (d(), c("li", {
            key: e,
            "data-item": JSON.stringify(e),
            class: L(["draggable", `draggable-${t.listId}`]),
            tabindex: "0",
            "aria-label": `Item ${o + 1}`,
            "data-sortable-id": o,
            "data-test": `${t.dataTest}-item-${o + 1}`
          }, [
            k("div", V, [
              t.displayPositionNumbers ? (d(), c("span", {
                key: 0,
                class: "puik-sortable-list_item-index",
                "data-test": `${t.dataTest}-list-item-index-${o + 1}`
              }, S(t.$attrs.dataSortableId || o + 1), 9, F)) : u("", !0),
              k("div", J, [
                t.iconPosition == g($).Left ? (d(), A(g(w), {
                  key: 0,
                  icon: "drag_indicator",
                  color: "#1D1D1B",
                  tabindex: "-1",
                  "data-test": `${t.dataTest}-left-icon-${o + 1}`
                }, null, 8, ["data-test"])) : u("", !0),
                e.imgSrc ? (d(), c("img", {
                  key: 1,
                  class: "puik-sortable-list_item-img",
                  src: e.imgSrc,
                  alt: "img alt",
                  "data-test": `${t.dataTest}-img-${o + 1}`
                }, null, 8, O)) : u("", !0),
                k("div", z, [
                  e.title ? (d(), c("p", {
                    key: 0,
                    class: "puik-sortable-list_item-content_title",
                    "data-test": `${t.dataTest}-title-${o + 1}`
                  }, S(`${e == null ? void 0 : e.title}`), 9, j)) : u("", !0),
                  e.description ? (d(), c("p", {
                    key: 1,
                    class: "puik-sortable-list_item-content_subtitle",
                    "data-test": `${t.dataTest}-description-${o + 1}`
                  }, S(`${e == null ? void 0 : e.description}`), 9, G)) : u("", !0),
                  B(t.$slots, "custom-content", {
                    element: e,
                    index: o
                  })
                ]),
                t.iconPosition == g($).Right ? (d(), A(g(w), {
                  key: 2,
                  icon: "drag_indicator",
                  color: "#1D1D1B",
                  tabindex: "-1",
                  "data-test": `${t.dataTest}-right-icon-${o + 1}`
                }, null, 8, ["data-test"])) : u("", !0)
              ])
            ])
          ], 10, R))
        ]),
        _: 3
      }, 8, ["sortable", "list", "item-key", "tag", "options"])
    ], 8, M));
  }
});
export {
  _t as default
};
