import { InjectionKey, Ref } from 'vue';
import { default as TabNavigation } from './tab-navigation.vue';
export interface TabNavigationProps {
    name: string;
    defaultPosition?: number;
}
export type TabNavigationEmits = {
    'change-active-tab': [position: number];
};
export type TabNavigationInstance = InstanceType<typeof TabNavigation>;
export type currentTabKeyContext = {
    name: Ref<string>;
    numberOfTabs: Ref<number>;
    currentPosition: Ref<number>;
    keyEventDirection: Ref<string | null | undefined>;
    handleTabClick: (index: number) => void;
};
export declare const currentTabKey: InjectionKey<currentTabKeyContext>;
