import { defineComponent as R, ref as d, createElementBlock as i, openBlock as o, createBlock as B, createCommentVNode as p, unref as t, createVNode as m, withCtx as V, createTextVNode as T, toDisplayString as f } from "vue";
import { useLocale as E } from "../../locale/hooks/use-locale.mjs";
import { PuikButton as x } from "../../button/index.mjs";
import { PuikInput as h } from "../../input/index.mjs";
import { PuikTableSearchInputTypes as v } from "./table-search-input.mjs";
import { PuikInputTypes as b } from "../../input/src/input.mjs";
const _ = { class: "puik-table__head__row__item__content puik-table-search-input__content" }, $ = {
  key: 1,
  class: "puik-table-search-input--range"
}, P = {
  key: 2,
  class: "puik-table-search-input--submit"
}, Y = /* @__PURE__ */ R({
  name: "PuikTableSearchInput",
  __name: "table-search-input",
  props: {
    name: { type: String },
    column: { default: "", type: String },
    searchSubmit: { type: Boolean },
    searchReset: { type: Boolean },
    searchType: { default: v.Text, type: null }
  },
  emits: ["searchTextValue", "searchRangeValue", "searchSubmitEvent", "searchResetEvent"],
  setup(I, { emit: N }) {
    const l = I, k = N, { t: n } = E(), c = d(), r = d(), s = d(), S = (u, e) => {
      k("searchTextValue", {
        searchBy: u,
        inputText: e
      });
    }, y = (u, e, a) => {
      const g = {
        searchBy: u,
        inputRange: {
          min: e || Number.NEGATIVE_INFINITY,
          max: a || Number.POSITIVE_INFINITY
        }
      };
      k("searchRangeValue", g);
    };
    return (u, e) => (o(), i("div", _, [
      !l.searchSubmit && l.searchType === t(v).Text ? (o(), B(t(h), {
        key: 0,
        modelValue: c.value,
        "onUpdate:modelValue": [
          e[0] || (e[0] = (a) => c.value = a),
          e[1] || (e[1] = (a) => S(l.column, c.value))
        ],
        type: t(b).Text,
        placeholder: t(n)("puik.table.search")
      }, null, 8, ["modelValue", "type", "placeholder"])) : p("", !0),
      !l.searchSubmit && l.searchType === t(v).Range ? (o(), i("div", $, [
        m(t(h), {
          modelValue: r.value,
          "onUpdate:modelValue": [
            e[2] || (e[2] = (a) => r.value = a),
            e[3] || (e[3] = (a) => y(l.column, r.value, s.value))
          ],
          type: t(b).Number,
          placeholder: t(n)("puik.table.min")
        }, null, 8, ["modelValue", "type", "placeholder"]),
        m(t(h), {
          modelValue: s.value,
          "onUpdate:modelValue": [
            e[4] || (e[4] = (a) => s.value = a),
            e[5] || (e[5] = (a) => y(l.column, r.value, s.value))
          ],
          type: t(b).Number,
          placeholder: t(n)("puik.table.max")
        }, null, 8, ["modelValue", "type", "placeholder"])
      ])) : p("", !0),
      l.searchSubmit ? (o(), i("div", P, [
        m(t(x), {
          "left-icon": "search",
          onClick: e[6] || (e[6] = (a) => u.$emit("searchSubmitEvent"))
        }, {
          default: V(() => [
            T(f(t(n)("puik.table.search")), 1)
          ]),
          _: 1
        }),
        l.searchReset ? (o(), i("div", {
          key: 0,
          class: "puik-table-search-input--reset",
          onClick: e[7] || (e[7] = (a) => u.$emit("searchResetEvent"))
        }, [
          m(t(x), {
            "left-icon": "close",
            variant: "text",
            size: "sm"
          }, {
            default: V(() => [
              T(f(t(n)("puik.table.reset")), 1)
            ]),
            _: 1
          })
        ])) : p("", !0)
      ])) : p("", !0)
    ]));
  }
});
export {
  Y as default
};
