import { defineComponent as ne, ref as v, computed as W, watch as U, createElementBlock as o, openBlock as s, createElementVNode as r, normalizeClass as p, createCommentVNode as n, createBlock as C, unref as c, withCtx as K, createTextVNode as B, toDisplayString as m, Fragment as $, renderList as F, normalizeStyle as X, renderSlot as N, withKeys as Y, createVNode as ce, withModifiers as de, toRaw as Z } from "vue";
import { useLocale as be } from "../../locale/hooks/use-locale.mjs";
import { PuikCheckbox as H } from "../../checkbox/index.mjs";
import { PuikButton as ke } from "../../button/index.mjs";
import { PuikIcon as ve } from "../../icon/index.mjs";
import { PuikSkeletonLoader as pe } from "../../skeleton-loader/index.mjs";
import { PuikTableSearchInput as ye } from "../index.mjs";
import { PuikTableSortIcon as S, PuikTableSortOrder as A } from "./table.mjs";
const me = ["data-test"], he = ["data-test"], fe = ["colspan"], we = { class: "puik-table__head__row" }, ge = ["data-test"], $e = {
  key: 1,
  class: "puik-sr-only"
}, Se = ["data-test"], Te = { class: "puik-table__head__row__item__container" }, Le = { class: "puik-table__head__row__item__content" }, Ce = ["data-test"], Be = ["colspan"], Fe = {
  key: 0,
  class: "puik-table__head__row puik-table__search__bar"
}, Ae = ["data-test"], Re = {
  key: 1,
  class: "puik-sr-only"
}, De = ["data-test"], Pe = {
  key: 0,
  class: "puik-table__head__row__item__container"
}, ze = { key: 1 }, Ve = ["colspan"], Ee = ["data-test"], We = { class: "puik-table__body__row" }, Ke = { class: "puik-table__body__row__item__container" }, Ne = ["onClick"], He = { class: "puik-table__body__row__item__container" }, Me = ["data-test"], je = ["colspan", "dataTest"], Oe = /* @__PURE__ */ ne({
  name: "PuikTable",
  __name: "table",
  props: {
    headers: { type: Array },
    items: { default: () => [], type: Array },
    expandable: { type: Boolean },
    selectable: { type: Boolean },
    selection: { default: () => [], type: Array },
    searchBar: { type: Boolean },
    searchFromServer: { type: Boolean },
    sortFromServer: { type: Boolean },
    fullWidth: { type: Boolean },
    stickyFirstCol: { type: Boolean },
    stickyLastCol: { type: Boolean },
    dataTest: { type: String }
  },
  emits: ["select", "select:all", "update:selection", "sortColumn", "searchSubmit", "searchResultsLocally"],
  setup(I, { emit: O }) {
    const _ = I, y = O, { t: h } = be(), b = v(_.selection), R = v([]), i = v("left"), x = v(0), f = v({}), w = v({}), T = v([..._.items]), M = v(""), g = v([]), z = v(!1), L = v(!1), j = v(0), q = (e) => {
      var t;
      const l = g.value.findIndex(
        (a) => a.searchBy === e.searchBy
      );
      l !== -1 && g.value.splice(l, 1), ((t = e.inputText) == null ? void 0 : t.length) !== 0 && g.value.push(e);
    }, ee = () => {
      j.value += 1;
    }, te = () => {
      L.value = !0, g.value = [], T.value = _.items, z.value = !1, ee(), L.value = !1, y("searchSubmit", Z(g.value)), _.sortFromServer || y("searchResultsLocally", _.items);
    }, ae = () => {
      L.value = !0;
      const e = _.items.filter((l) => g.value.every((t) => {
        var a, u, d;
        return l[t.searchBy] && t.inputText !== void 0 && t.inputText !== "" ? l[t.searchBy].toString().toLowerCase().trim().includes((a = t == null ? void 0 : t.inputText) == null ? void 0 : a.toLowerCase().trim()) : l[t.searchBy] && ((u = t == null ? void 0 : t.inputRange) == null ? void 0 : u.min) !== void 0 && ((d = t == null ? void 0 : t.inputRange) == null ? void 0 : d.max) !== void 0 ? t.inputRange.min <= l[t.searchBy] && t.inputRange.max >= l[t.searchBy] : !0;
      }));
      L.value = !1, T.value = e, y("searchResultsLocally", e);
    }, G = () => {
      z.value = !0, _.searchFromServer || ae(), y("searchSubmit", Z(g.value));
    }, le = () => {
      for (const e in w.value)
        w.value[e] = S.Default;
    }, se = (e) => {
      f.value[e] ? (f.value[e] = f.value[e] === A.Asc && M.value === e ? A.Desc : A.Asc, w.value[e] = f.value[e] === A.Asc ? S.Asc : S.Desc) : (f.value[e] = A.Asc, w.value[e] = S.Asc);
    }, ie = (e) => {
      const l = f.value[e] === A.Asc ? 1 : -1;
      T.value.sort((t, a) => {
        const u = typeof t[e] == "string" ? t[e].toLowerCase() : t[e], d = typeof a[e] == "string" ? a[e].toLowerCase() : a[e];
        return l * (u < d ? -1 : u > d ? 1 : 0);
      });
    }, oe = (e) => {
      _.sortFromServer || ie(e), le(), se(e);
      const l = {
        sortBy: e,
        sortOrder: f.value[e]
      };
      return y("sortColumn", l), M.value = e, T.value;
    }, _e = async (e) => {
      const l = e.target;
      l.scrollLeft === 0 ? i.value = "left" : Math.abs(l.scrollLeft + l.offsetWidth - l.scrollWidth) < 28 ? i.value = "right" : i.value = "isScrolling", x.value = l.scrollLeft;
    }, k = (e, l = _.selectable, t = _.expandable) => l || t ? _.stickyLastCol && e === _.headers.length - 1 : _.stickyFirstCol && e === 0 || _.stickyLastCol && e === _.headers.length - 1, V = (e) => {
      const l = R.value.indexOf(e);
      l !== -1 ? R.value.splice(l, 1) : R.value.push(e);
    }, D = W(() => b.value.length > 0 && b.value.length < _.items.length), P = W(() => D.value ? !1 : b.value.length === _.items.length), J = () => {
      D.value || !P.value ? b.value = _.items.map((...e) => e[1]) : b.value = [], y("select:all"), y("update:selection", b.value);
    }, E = (e) => b.value.some((l) => l === e), ue = (e) => {
      E(e) ? b.value = b.value.filter((l) => l !== e) : b.value.push(e), y("select", e), y("update:selection", b.value);
    }, Q = W(() => h(
      `puik.table.${D.value || !P.value ? "selectAllLabel" : "unselectAllLabel"}`
    )), re = (e) => h(
      `puik.table.${E(e) ? "unselectLabel" : "selectLabel"}`
    );
    return U(
      () => _.selection,
      () => {
        b.value = _.selection;
      }
    ), U(
      () => _.items,
      (e) => {
        T.value = [...e];
      }
    ), (e, l) => (s(), o("div", {
      class: "puik-table__container puik-scrollbar",
      onScroll: _e
    }, [
      r("table", {
        class: p(["puik-table", { "puik-table--full-width": e.fullWidth }]),
        "data-test": e.dataTest != null ? `table-${e.dataTest}` : void 0
      }, [
        r("thead", {
          class: "puik-table__head",
          "data-test": e.dataTest != null ? `table-header-${e.dataTest}` : void 0
        }, [
          r("tr", null, [
            r("td", {
              colspan: e.selectable || e.expandable ? e.headers.length + 1 : e.headers.length
            }, l[0] || (l[0] = [
              r("div", { class: "puik-table__head-separator" }, null, -1)
            ]), 8, fe)
          ]),
          r("tr", we, [
            e.selectable || e.expandable ? (s(), o("th", {
              key: 0,
              class: p([
                "puik-table__head__row__item",
                { "puik-table__head__row__item--sticky": e.stickyFirstCol },
                {
                  "puik-table__head__row__item--sticky-scroll": e.stickyFirstCol && (i.value === "isScrolling" || i.value === "right")
                },
                { "puik-table__head__row__item--selection": e.selectable },
                { "puik-table__head__row__item--expandable": e.expandable }
              ]),
              "data-test": e.dataTest != null ? `table-header-th-${e.dataTest}-selection` : void 0
            }, [
              e.selectable && !e.searchBar ? (s(), C(c(H), {
                key: 0,
                "model-value": P.value,
                indeterminate: D.value,
                "data-test": e.dataTest != null ? `table-header-checkbox-${e.dataTest}` : void 0,
                class: "puik-table__head__row__item--selection__checkbox",
                onClick: J
              }, {
                default: K(() => [
                  B(m(Q.value), 1)
                ]),
                _: 1
              }, 8, ["model-value", "indeterminate", "data-test"])) : n("", !0),
              e.expandable ? (s(), o("span", $e, m(c(h)("puik.table.expandableHeaderLabel")), 1)) : n("", !0)
            ], 10, ge)) : n("", !0),
            (s(!0), o($, null, F(e.headers, (t, a) => (s(), o("th", {
              key: `headers${t.value}`,
              class: p([
                `puik-table__head__row__item puik-table__head__row__item--${t.align ?? "left"}`,
                {
                  [`puik-table__head__row__item--${t.size}`]: (t == null ? void 0 : t.size) && !(t != null && t.width)
                },
                {
                  "puik-table__head__row__item--sortable": t == null ? void 0 : t.sortable
                },
                { "puik-table__head__row__item--sticky": k(a) },
                {
                  "puik-table__head__row__item--sticky-scroll": k(a) && i.value === "isScrolling"
                },
                {
                  "puik-table__head__row__item--sticky-left": k(a) && i.value === "left"
                },
                {
                  "puik-table__head__row__item--sticky-right": k(a) && i.value === "right"
                }
              ]),
              style: X({ minWidth: t.width, width: t.width }),
              "data-test": e.dataTest != null ? `table-header-th-${e.dataTest}-${t.value}` : void 0
            }, [
              r("div", Te, [
                r("div", Le, [
                  r("span", {
                    "data-test": e.dataTest != null ? `table-header-content-${e.dataTest}-${t.value}` : void 0
                  }, [
                    N(e.$slots, `header-${t.value}`, {
                      header: t,
                      index: a
                    }, () => [
                      B(m((t == null ? void 0 : t.text) || (t == null ? void 0 : t.value)), 1)
                    ])
                  ], 8, Ce),
                  t.sortable ? (s(), C(c(ke), {
                    key: 0,
                    class: "puik-table__head__row__item__content__sort-btn",
                    "right-icon": w.value[t.value] ?? c(S).Default,
                    variant: "primary-reverse",
                    size: "sm",
                    "aria-label": w.value[t.value] === c(S).Asc ? `${c(h)("puik.table.sortableAscLabel")} ${t.value}` : w.value[t.value] === c(S).Desc ? `${c(h)("puik.table.sortableDescLabel")} ${t.value}` : `${c(h)("puik.table.sortableDefaultLabel")} ${t.value}`,
                    "data-test": e.dataTest != null ? `table-header-sort-${e.dataTest}-${t.value}` : void 0,
                    onClick: (u) => oe(t.value)
                  }, null, 8, ["right-icon", "aria-label", "data-test", "onClick"])) : n("", !0)
                ])
              ])
            ], 14, Se))), 128))
          ]),
          r("tr", null, [
            r("td", {
              colspan: e.selectable || e.expandable ? e.headers.length + 1 : e.headers.length
            }, l[1] || (l[1] = [
              r("div", { class: "puik-table__head-separator" }, null, -1)
            ]), 8, Be)
          ]),
          e.searchBar ? (s(), o("tr", Fe, [
            e.selectable || e.expandable ? (s(), o("th", {
              key: 0,
              class: p([
                "puik-table__head__row__item",
                { "puik-table__head__row__item--sticky": e.stickyFirstCol },
                {
                  "puik-table__head__row__item--sticky-scroll": e.stickyFirstCol && (i.value === "isScrolling" || i.value === "right")
                },
                { "puik-table__head__row__item--selection": e.selectable },
                { "puik-table__head__row__item--expandable": e.expandable }
              ]),
              "data-test": e.dataTest != null ? `table-header-th-${e.dataTest}-searchBar-selection` : void 0
            }, [
              e.selectable ? (s(), C(c(H), {
                key: 0,
                "model-value": P.value,
                indeterminate: D.value,
                "data-test": e.dataTest != null ? `table-header-checkbox-${e.dataTest}-searchBar` : void 0,
                class: "puik-table__head__row__item--selection__checkbox",
                onClick: J
              }, {
                default: K(() => [
                  B(m(Q.value), 1)
                ]),
                _: 1
              }, 8, ["model-value", "indeterminate", "data-test"])) : n("", !0),
              e.expandable ? (s(), o("span", Re, m(c(h)("puik.table.expandableHeaderLabel")), 1)) : n("", !0)
            ], 10, Ae)) : n("", !0),
            (s(!0), o($, null, F(e.headers, (t, a) => (s(), o("th", {
              key: `headers-${t.value}`,
              class: p([
                `puik-table__head__row__item puik-table__head__row__item--${t.align ?? "left"}`,
                {
                  [`puik-table__head__row__item--${t.size}`]: (t == null ? void 0 : t.size) && !(t != null && t.width)
                },
                {
                  "puik-table__head__row__item--sortable": t == null ? void 0 : t.sortable
                },
                { "puik-table__head__row__item--sticky": k(a) },
                {
                  "puik-table__head__row__item--sticky-scroll": k(a) && i.value === "isScrolling"
                },
                {
                  "puik-table__head__row__item--sticky-left": k(a) && i.value === "left"
                },
                {
                  "puik-table__head__row__item--sticky-right": k(a) && i.value === "right"
                }
              ]),
              style: X({ minWidth: t.width, width: t.width }),
              "data-test": e.dataTest != null ? `table-header-th-${e.dataTest}-${t.value}-searchBar` : void 0
            }, [
              t.searchable || t.searchSubmit ? (s(), o("div", Pe, [
                (s(), C(c(ye), {
                  key: `search-${t.value}-${j.value}`,
                  name: `search-${t.value}`,
                  column: t.value,
                  "search-submit": t.searchSubmit,
                  "search-reset": z.value,
                  "search-type": t.searchType,
                  "data-test": e.dataTest != null ? `${e.dataTest}-${t.value}` : void 0,
                  onSearchTextValue: q,
                  onSearchRangeValue: q,
                  onSearchSubmitEvent: G,
                  onSearchResetEvent: te,
                  onKeyup: Y(G, ["enter"])
                }, null, 8, ["name", "column", "search-submit", "search-reset", "search-type", "data-test"]))
              ])) : n("", !0)
            ], 14, De))), 128))
          ])) : n("", !0),
          e.searchBar ? (s(), o("tr", ze, [
            r("td", {
              colspan: e.selectable ? e.headers.length + 1 : e.headers.length
            }, l[2] || (l[2] = [
              r("div", { class: "puik-table__head-separator" }, null, -1)
            ]), 8, Ve)
          ])) : n("", !0)
        ], 8, he),
        r("tbody", {
          class: "puik-table__body",
          "data-test": e.dataTest != null ? `table-body-${e.dataTest}` : void 0
        }, [
          L.value ? (s(!0), o($, { key: 0 }, F(_.items, (t, a) => (s(), o("tr", {
            key: `row-${a}`
          }, [
            (s(!0), o($, null, F(e.headers, (u, d) => (s(), o("td", {
              key: d,
              class: "puik-table__body__row__item--loading"
            }, [
              ce(c(pe), { variant: "jumbotron" })
            ]))), 128))
          ]))), 128)) : n("", !0),
          L.value ? n("", !0) : (s(!0), o($, { key: 1 }, F(T.value, (t, a) => (s(), o($, {
            key: `row-${a}`
          }, [
            r("tr", We, [
              e.selectable || e.expandable ? (s(), o("td", {
                key: 0,
                class: p([
                  "puik-table__body__row__item puik-table__body__row__item--selection",
                  {
                    "puik-table__body__row__item--sticky": e.stickyFirstCol
                  },
                  {
                    "puik-table__body__row__item--sticky-scroll": e.stickyFirstCol && i.value === "isScrolling"
                  },
                  {
                    "puik-table__body__row__item--sticky-left": e.stickyFirstCol && i.value === "left"
                  },
                  {
                    "puik-table__body__row__item--sticky-right": e.stickyFirstCol && i.value === "right"
                  }
                ])
              }, [
                r("div", Ke, [
                  e.selectable ? (s(), C(c(H), {
                    key: 0,
                    "model-value": E(a),
                    class: "puik-table__body__row__item--selection__checkbox",
                    "data-test": e.dataTest != null ? `table-body-checkbox-${a}-${e.dataTest}` : void 0,
                    onClick: (u) => ue(a)
                  }, {
                    default: K(() => [
                      B(m(re(a)), 1)
                    ]),
                    _: 2
                  }, 1032, ["model-value", "data-test", "onClick"])) : n("", !0),
                  e.expandable ? (s(), C(c(ve), {
                    key: 1,
                    tabindex: "0",
                    class: p([
                      { "puik-icon__expand": R.value.includes(a) }
                    ]),
                    icon: "keyboard_arrow_down",
                    "font-size": "24",
                    "data-test": e.dataTest != null ? `table-body-icon-${a}-${e.dataTest}` : void 0,
                    onClick: (u) => V(a),
                    onKeydown: Y(de((u) => V(a), ["prevent"]), ["space"])
                  }, null, 8, ["class", "data-test", "onClick", "onKeydown"])) : n("", !0)
                ])
              ], 2)) : n("", !0),
              (s(!0), o($, null, F(e.headers, (u, d) => (s(), o("td", {
                key: `col-${d}`,
                class: p([
                  `puik-table__body__row__item puik-table__body__row__item--${u.align ?? "left"}`,
                  {
                    "puik-table__body__row__item--expand-row": e.expandable && !(u != null && u.preventExpand)
                  },
                  { "puik-table__body__row__item--sticky": k(d) },
                  {
                    "puik-table__body__row__item--sticky-scroll": k(d) && i.value === "isScrolling"
                  },
                  {
                    "puik-table__body__row__item--sticky-left": k(d) && i.value === "left"
                  },
                  {
                    "puik-table__body__row__item--sticky-right": k(d) && i.value === "right"
                  }
                ]),
                onClick: (qe) => e.expandable && !(u != null && u.preventExpand) ? V(a) : ""
              }, [
                r("div", He, [
                  r("div", {
                    class: "puik-table__body__row__item__content",
                    "data-test": e.dataTest != null ? `table-body-item-${a}-${u.value}-${e.dataTest}` : void 0
                  }, [
                    N(e.$slots, `item-${u.value}`, {
                      item: t,
                      index: a
                    }, () => [
                      B(m(t[u.value]), 1)
                    ])
                  ], 8, Me)
                ])
              ], 10, Ne))), 128))
            ]),
            R.value.includes(a) ? (s(), o("tr", {
              key: `expanded-row-${a}`,
              class: "puik-table__body__row--expanded"
            }, [
              e.stickyFirstCol ? (s(), o("td", {
                key: 0,
                class: p([
                  "puik-table__body__row__item puik-table__body__row__item--selection",
                  { "puik-table__body__row__item--sticky": e.stickyFirstCol },
                  {
                    "puik-table__body__row__item--sticky-scroll": e.stickyFirstCol && i.value === "isScrolling"
                  },
                  {
                    "puik-table__body__row__item--sticky-left": e.stickyFirstCol && i.value === "left"
                  },
                  {
                    "puik-table__body__row__item--sticky-right": e.stickyFirstCol && i.value === "right"
                  }
                ])
              }, null, 2)) : n("", !0),
              r("td", {
                colspan: e.stickyFirstCol && e.stickyLastCol ? e.headers.length - 1 : e.headers.length,
                class: "puik-table__body__row__item puik-table__body__row__item--expanded",
                dataTest: e.dataTest != null ? `table-body-expanded-${a}-${e.dataTest}` : void 0
              }, [
                N(e.$slots, "expanded-row", {
                  item: t,
                  index: a
                }, () => [
                  B(m(t), 1)
                ])
              ], 8, je),
              e.stickyLastCol ? (s(), o("td", {
                key: 1,
                class: p([
                  "puik-table__body__row__item puik-table__body__row__item--selection",
                  { "puik-table__body__row__item--sticky": e.stickyLastCol },
                  {
                    "puik-table__body__row__item--sticky-scroll": e.stickyLastCol && i.value === "isScrolling"
                  },
                  {
                    "puik-table__body__row__item--sticky-left": e.stickyLastCol && i.value === "left"
                  },
                  {
                    "puik-table__body__row__item--sticky-right": e.stickyLastCol && i.value === "right"
                  }
                ])
              }, null, 2)) : n("", !0)
            ])) : n("", !0)
          ], 64))), 128))
        ], 8, Ee)
      ], 10, me)
    ], 32));
  }
});
export {
  Oe as default
};
