import { defineComponent as C, useSlots as q, ref as x, computed as m, onMounted as E, watch as h, createElementBlock as o, openBlock as l, normalizeClass as b, createCommentVNode as u, createElementVNode as d, toDisplayString as _, withDirectives as w, isRef as R, vModelText as I, unref as B, renderSlot as S, vShow as M, createVNode as z, createTextVNode as D, nextTick as G } from "vue";
import { useVModel as P } from "@vueuse/core";
import { slotIsEmpty as W } from "../../utils/types.mjs";
import { clamp as U } from "../../utils/clamp.mjs";
import { PuikIcon as j } from "../../icon/index.mjs";
const A = {
  key: 0,
  class: "puik-textarea__character-count"
}, J = ["id", "name", "placeholder", "autofocus", "disabled", "readonly", "required", "aria-invalid", "aria-label"], K = {
  key: 1,
  class: "puik-textarea__hint",
  role: "alert",
  "aria-live": "assertive"
}, O = {
  key: 0,
  class: "puik-textarea__hint__text"
}, Q = {
  key: 1,
  class: "puik-textarea__hint__error"
}, X = { class: "puik-textarea__hint__error__text" }, re = /* @__PURE__ */ C({
  name: "PuikTextarea",
  __name: "textarea",
  props: {
    id: { type: String },
    name: { type: String },
    modelValue: { type: String },
    placeholder: { type: String },
    autofocus: { type: Boolean },
    disabled: { type: Boolean },
    readonly: { type: Boolean },
    required: { type: Boolean },
    maxLength: { type: Number },
    error: { type: String },
    hideHint: { type: Boolean },
    autoGrow: { type: Boolean, default: !0 },
    rows: { default: 2, type: Number },
    maxRows: { default: 2, type: Number },
    ariaLabel: { type: String }
  },
  emits: ["update:modelValue", "blur"],
  setup(V, { emit: F }) {
    const H = q(), t = V, y = F, s = P(t, "modelValue", y), a = x(), p = x(!1), L = () => p.value = !0, N = (e) => {
      p.value = !1, y("blur", e);
    }, r = m(() => t.error || W(H.error)), f = m(() => {
      var e;
      return ((e = s.value) == null ? void 0 : e.length) || 0;
    }), i = () => {
      t.autoGrow && G(() => {
        if (!a.value) return;
        const e = getComputedStyle(a.value), n = parseFloat(e.borderTopWidth) + parseFloat(e.borderBottomWidth), c = parseFloat(e.paddingTop) + parseFloat(e.paddingBottom), v = n + c, g = parseFloat(e.lineHeight), k = t.rows * g + v, $ = t.maxRows * g + v || 1 / 0;
        a.value.style.height = `${k}px`, a.value.style.height = `${U(
          a.value.scrollHeight,
          k,
          $
        )}px`;
      });
    }, T = m(() => ({
      "puik-textarea__wrapper--focus": p.value,
      "puik-textarea__wrapper--disabled": t.disabled,
      "puik-textarea__wrapper--readonly": t.readonly,
      "puik-textarea__wrapper--error": r.value
    }));
    return E(i), h(() => t.modelValue, i), h(() => t.maxRows, i), h(() => t.rows, i), (e, n) => (l(), o("div", {
      class: b(["puik-textarea", {
        "puik-textarea--count-error": e.maxLength && f.value > e.maxLength
      }])
    }, [
      e.maxLength ? (l(), o("div", A, [
        d("span", null, _(f.value) + "/" + _(e.maxLength), 1)
      ])) : u("", !0),
      d("div", {
        class: b(["puik-textarea__wrapper", T.value])
      }, [
        w(d("textarea", {
          id: e.id,
          ref_key: "textarea",
          ref: a,
          "onUpdate:modelValue": n[0] || (n[0] = (c) => R(s) ? s.value = c : null),
          class: "puik-textarea__field",
          name: e.name,
          placeholder: e.placeholder,
          autofocus: e.autofocus,
          disabled: e.disabled,
          readonly: e.readonly,
          required: e.required,
          "aria-invalid": r.value ? "true" : "false",
          "aria-label": e.ariaLabel ?? "undefined",
          onFocus: L,
          onBlur: N
        }, null, 40, J), [
          [I, B(s)]
        ])
      ], 2),
      e.$slots.hint || r.value ? (l(), o("div", K, [
        e.$slots.hint && !r.value ? w((l(), o("span", O, [
          S(e.$slots, "hint")
        ], 512)), [
          [M, !e.hideHint]
        ]) : u("", !0),
        r.value ? (l(), o("div", Q, [
          z(B(j), {
            icon: "error",
            class: "puik-textarea__hint__error__icon",
            "font-size": "1.25rem"
          }),
          d("span", X, [
            S(e.$slots, "error", {}, () => [
              D(_(e.error), 1)
            ])
          ])
        ])) : u("", !0)
      ])) : u("", !0)
    ], 2));
  }
});
export {
  re as default
};
