import { defineComponent as g, ref as p, onMounted as $, onUnmounted as b, createElementBlock as r, openBlock as u, createElementVNode as d, withDirectives as w, withKeys as S, renderSlot as m, normalizeStyle as D, normalizeClass as z, createCommentVNode as f, createTextVNode as h, toDisplayString as y, vShow as B } from "vue";
import { createPopper as M } from "@popperjs/core";
import { generateId as N } from "../../utils/rand.mjs";
import { PuikTooltipPositions as V } from "./tooltip.mjs";
const W = ["data-test"], C = ["aria-expanded", "data-test"], P = ["aria-hidden", "data-test"], E = { class: "puik-tooltip__tip__content" }, K = ["data-test"], F = ["data-test"], A = /* @__PURE__ */ g({
  name: "PuikTooltip",
  __name: "tooltip",
  props: {
    heading: { type: String },
    description: { type: String },
    position: { default: V.Bottom, type: null },
    isDisabled: { type: Boolean },
    maxWidth: { type: String },
    zindex: { default: 1e3, type: Number },
    disappearDelay: { default: 50, type: Number },
    dataTest: { default: "tooltip", type: String }
  },
  setup(_) {
    const a = p(null), s = p(null), e = p(!1);
    let o = null;
    const v = `puik-tooltip-${N()}`, c = _, n = () => {
      e.value = !0, o == null || o.update();
    }, k = () => {
      e.value = !1;
    }, T = () => {
      e.value = !0;
    }, l = () => {
      setTimeout(() => {
        var t, i;
        !((t = a.value) != null && t.matches(":hover")) && !((i = s.value) != null && i.matches(":hover")) && k();
      }, c.disappearDelay);
    };
    return $(() => {
      a.value && s.value && (o = M(a.value, s.value, {
        placement: c.position,
        modifiers: [{ name: "offset", options: { offset: [0, 12] } }]
      }));
    }), b(() => {
      o == null || o.destroy(), o = null;
    }), (t, i) => (u(), r("div", {
      class: "puik-tooltip",
      "data-test": t.dataTest
    }, [
      d("div", {
        ref_key: "slotWrapper",
        ref: a,
        class: "puik-tooltip__slot--wrapper",
        tabindex: "0",
        "aria-describedby": v,
        "aria-expanded": e.value,
        "data-test": t.dataTest ? `slot-content-${t.dataTest}` : void 0,
        onMouseover: n,
        onMouseleave: l,
        onFocus: n,
        onBlur: l,
        onKeydown: S(l, ["esc"]),
        onClick: n
      }, [
        m(t.$slots, "default")
      ], 40, C),
      w(d("div", {
        id: v,
        ref_key: "tooltip",
        ref: s,
        role: "tooltip",
        class: z([
          "puik-tooltip__tip",
          { "puik-tooltip--visible": e.value }
        ]),
        style: D({ "z-index": e.value ? t.zindex : -1, "max-width": t.maxWidth ? `${t.maxWidth}px` : "max-content" }),
        "aria-live": "polite",
        "aria-hidden": !e.value,
        onMouseover: T,
        onMouseleave: l,
        "data-test": t.dataTest ? `tip-content-${t.dataTest}` : void 0
      }, [
        d("div", E, [
          t.$slots.heading || t.heading ? (u(), r("span", {
            key: 0,
            class: "puik-tooltip__tip__content__heading",
            "data-test": t.dataTest ? `heading-${t.dataTest}` : void 0
          }, [
            m(t.$slots, "heading", {}, () => [
              h(y(t.heading), 1)
            ])
          ], 8, K)) : f("", !0),
          t.$slots.description || t.description ? (u(), r("span", {
            key: 1,
            class: "puik-tooltip__tip__content__description",
            "data-test": t.dataTest ? `description-${t.dataTest}` : void 0
          }, [
            m(t.$slots, "description", {}, () => [
              h(y(t.description), 1)
            ])
          ], 8, F)) : f("", !0)
        ]),
        i[0] || (i[0] = d("div", {
          class: "puik-tooltip__tip__arrow",
          "data-popper-arrow": ""
        }, null, -1))
      ], 46, P), [
        [B, !t.isDisabled && e.value]
      ])
    ], 8, W));
  }
});
export {
  A as default
};
